<?php
namespace App\Controller;

use App\Controller\AppController;

/**
 * Adelantos Controller
 *
 * @property \App\Model\Table\AdelantosTable $Adelantos
 */
class AdelantosController extends AppController
{

    /**
     * Index method
     *
     * @return \Cake\Network\Response|null
     */
    public function index()
    {
        $mesesN=array(1=>"ENERO","FEBRERO","MARZO","ABRIL","MAYO","JUNIO","JULIO",
             "AGOSTO","SEPTIEMBRE","OCTUBRE","NOVIEMBRE","DICIEMBRE");
        $ultimodia=array(1=>"31","28","31","30","31","30","31","31","30","31","30","31");

        $hoy = getdate();
        //$hoy['year']
        $sql = "";
        if($hoy['mday'] >= 1 and $hoy['mday'] <= 5){
             $this->set('mes', $mesesN[$hoy['mon']-1]);

             $sql = "to_date(fecha,'dd/MM/yyyy')  between to_date('01/".($hoy['mon']-1)."/" . $hoy['year'] . "','dd/mm/yyyy') and 
             to_date('".$ultimodia[($hoy['mon']-1)]."/".($hoy['mon']-1)."/" . $hoy['year']. "','dd/mm/yyyy')";
        }else{
             $this->set('mes', $mesesN[$hoy['mon']]);

              $sql = "to_date(fecha,'dd/MM/yyyy')  between to_date('01/".$hoy['mon']."/" . $hoy['year'] . "','dd/mm/yyyy') and to_date('".$ultimodia[$hoy['mon']]."/".$hoy['mon']."/" . $hoy['year']. "','dd/mm/yyyy')";
        }

        if($this->Auth->User('empleado') == 42 or $this->Auth->User('empleado') == 80){
            $sql = "";
        }

        $adelantos = $this->paginate($this->Adelantos, 
        [
            'conditions' => [
                'Adelantos.empleado' => $this->Auth->User('empleado'),
                $sql
            ],
            'order' => ['id' => 'desc'] 
            
            ] );

        $this->set(compact('adelantos'));
        $this->set('_serialize', ['adelantos']);
    }

    /**
     * View method
     *
     * @param string|null $id Adelanto id.
     * @return \Cake\Network\Response|null
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $adelanto = $this->Adelantos->get($id, [
            'contain' => []
        ]);

        $this->set('adelanto', $adelanto);
        $this->set('_serialize', ['adelanto']);
    }

    /**
     * Add method
     *
     * @return \Cake\Network\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $adelanto = $this->Adelantos->newEntity();
        if ($this->request->is('post')) {
            $adelanto = $this->Adelantos->patchEntity($adelanto, $this->request->data);
            if ($this->Adelantos->save($adelanto)) {
                $this->Flash->success(__('The adelanto has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The adelanto could not be saved. Please, try again.'));
        }
        $this->set(compact('adelanto'));
        $this->set('_serialize', ['adelanto']);
    }

    /**
     * Edit method
     *
     * @param string|null $id Adelanto id.
     * @return \Cake\Network\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $adelanto = $this->Adelantos->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $adelanto = $this->Adelantos->patchEntity($adelanto, $this->request->data);
            if ($this->Adelantos->save($adelanto)) {
                $this->Flash->success(__('The adelanto has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The adelanto could not be saved. Please, try again.'));
        }
        $this->set(compact('adelanto'));
        $this->set('_serialize', ['adelanto']);
    }

    /**
     * Delete method
     *
     * @param string|null $id Adelanto id.
     * @return \Cake\Network\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $adelanto = $this->Adelantos->get($id);
        if ($this->Adelantos->delete($adelanto)) {
            $this->Flash->success(__('The adelanto has been deleted.'));
        } else {
            $this->Flash->error(__('The adelanto could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
