<?php

namespace App\Controller;

use App\Controller\AppController;
use Cake\ORM\TableRegistry;
use Cake\Datasource\ConnectionManager;

class AsignarcvsController extends AppController
{

    public function initialize()
    {
        parent::initialize();
        $this->loadComponent('RequestHandler');
    }

    public function beforeFilter(\Cake\Event\Event $event)
    {
        parent::beforeFilter($event);
        $this->Auth->allow(['ajaxasignar']);
    }

    public function index()
    {
        $this->set('choferes', TableRegistry::get('choferes')->find('list'));
        $this->set('cv', TableRegistry::get('funcionariocvs')->find('list')->where(['funcionariocvs.borrado' => 0])->order(['funcionariocvs.nombre' => 'ASC']));

        if (!empty($this->request->query['search']) || !empty($this->request->query['search2'])) {

            $this->paginate = [
                'contain' => ['choferes'],
                'conditions' => [],
                 'order' => ['asignarcvs.id' => 'desc']
            ];

            $search = $this->request->query['search'];
            $search2 = $this->request->query['search2'];

            if (!empty($search)) {
                $this->paginate['conditions']['asignarcvs.choferid'] = $search;
            }
            if (!empty($search2)) {
                $this->paginate['conditions']['asignarcvs.chasis ilike'] = '%' . $search2 . '%';
            }

            $this->paginate['order'] = [
                'asignarcvs.id' => 'desc'
            ];

            $asignarcvs = $this->paginate($this->Asignarcvs);

            $this->set(compact('asignarcvs', 'search', 'search2'));
        } else {
            $this->set('asignarcvs', []);
            $this->set('search', '');
            $this->set('search2', '');
        }
    }

    public function view($id = null)
    {
        $asignarcv = $this->Asignarcvs->get($id, [
            'contain' => ['choferes'],
        ]);

        $this->set('asignarcv', $asignarcv);
    }

    public function add()
    {
        $asignarcv = $this->Asignarcvs->newEntity();
        if ($this->request->is('post')) {
            $asignarcv = $this->Asignarcvs->patchEntity($asignarcv, $this->request->getData());
            if ($this->Asignarcvs->save($asignarcv)) {
                $this->Flash->success(__('Se guardo correctamente!'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('Error al registrar, intente nuevamente!'));
        }
        $choferes = $this->Asignarcvs->choferes->find('list', ['limit' => 200]);
        $this->set(compact('asignarcv', 'choferes'));
    }

    public function edit($id = null)
    {
        $asignarcv = $this->Asignarcvs->get($id, [
            'contain' => [],
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $asignarcv = $this->Asignarcvs->patchEntity($asignarcv, $this->request->getData());
            if ($this->Asignarcvs->save($asignarcv)) {
                $this->Flash->success(__('Modificado correctamente!'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('Error al modificar, intente de nuevo!'));
        }
        $choferes = $this->Asignarcvs->choferes->find('list', ['limit' => 200]);
        $this->set(compact('asignarcv', 'choferes'));
    }

    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $asignarcv = $this->Asignarcvs->get($id);
        if ($this->Asignarcvs->delete($asignarcv)) {
            $this->Flash->success(__('Eliminado correctamente!'));
        } else {
            $this->Flash->error(__('Error al eliminar dato, intente de nuevo!'));
        }

        return $this->redirect(['action' => 'index']);
    }

    public function ajaxasignar($id = null)
    {

        $this->render(false);
        if ($this->request->is('post')) {
            $cv = $this->request->getData("vend");
          //  $sql = 'INSERT INTO cvs(fecha, empleado, usuarioapp, chasis, monto, cantidadpieza, total, entrega, estado, comision, tipotrabajo, estadocomision, manoobra, diferencia, encuerinado, tornero, material, nogal, reclamo, estado_manoobra, estado_diferencia, estado_encuerinado, estado_tornero, estado_material, estado_nogal, estado_reclamo) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? ,?, ?, ?, ?, ?, ?, ?);';
            $sql = 'INSERT INTO cvs(fecha, empleado, usuarioapp, chasis, monto, cantidadpieza, total, manoobra, estado_manoobra) VALUES ( ?, ?, ?, ?, ?,  ?, ?, ?, ?);';

            $hoy = getdate();
            $dia = $hoy['mday'];
            if ($dia < 10) {
                $dia = "0" . $hoy['mday'];
            }
            $mes = $hoy['mon'];
            if ($mes < 10) {
                $mes = "0" . $hoy['mon'];
            }
            $ano = $hoy['year'];

            $fecha = $dia . "/" . $mes . "/" . $ano;

            $asignarcv = $this->Asignarcvs->get($id);

            $costo = 0;

            $diferencia  = 0;
            $encuerinado = 0;
            $tornero = 0;
            $material  = 0;
            $nogal  = 0;
            $reclamo = 0;
            $total = 1830000;
            $manoobra = 1830000;

          /*  $costoquery = TableRegistry::get('cvcostos')->find('all', ['conditions' => ['chasis' => $asignarcv->chasis]]);

            foreach ($costoquery->all() as $data) {

                //$datass = $data;
                $costo = $data->costo;
                $diferencia  = $data->diferencia;
                $encuerinado = $data->encuerinado;
                $tornero = $data->tornero;
                $material  = $data->material;
                $nogal  = $data->nogal;
                $reclamo = $data->reclamo;
            }

            $total = $costo + $diferencia + $encuerinado + $tornero + $material + $nogal + $reclamo;
            */

            $connection = ConnectionManager::get('default');
            
            //$sql = 'INSERT INTO cvs(fecha, empleado, usuarioapp, chasis, monto, cantidadpieza, total, manoobra, estado_manoobra) VALUES ( ?, ?, ?, ?, ?,  ?, ?, ?, ?);';

            $connection->execute($sql, [$fecha, $cv, 0, $asignarcv->chasis,  $costo, 1, $total, $manoobra, 0]);
            $connection->execute("UPDATE detalle_compra SET dc_estado=? WHERE dc_id=?", [2, $id]);

            //$connection->execute("INSERT INTO aaa(a) VALUES (?)", [$datass]);

            $connection->commit();
            $connection->disconnect();
        }
    }
}
