<?php
namespace App\Controller;

use App\Controller\AppController;

/**
 * CalidadConstruccions Controller
 *
 * @property \App\Model\Table\CalidadConstruccionsTable $CalidadConstruccions
 *
 * @method \App\Model\Entity\CalidadConstruccion[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class CalidadConstruccionsController extends AppController
{

    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        $calidadConstruccions = $this->paginate($this->CalidadConstruccions);

        $this->set(compact('calidadConstruccions'));
    }

    /**
     * View method
     *
     * @param string|null $id Calidad Construccion id.
     * @return \Cake\Http\Response|void
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $calidadConstruccion = $this->CalidadConstruccions->get($id, [
            'contain' => []
        ]);

        $this->set('calidadConstruccion', $calidadConstruccion);
    }

    
    public function simulador($id = null)
    {
        $calidadConstruccion = $this->CalidadConstruccions->find('list', ['limit' => 200]);

        $this->set('calidadConstruccion', $calidadConstruccion);
    }


     public function cuotafinal($id = null)
    {
        $calidadConstruccion = $this->CalidadConstruccions->find('all');
 
 
        $this->set('calidadConstruccions', $calidadConstruccion);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $calidadConstruccion = $this->CalidadConstruccions->newEntity();
        if ($this->request->is('post')) {
            $calidadConstruccion = $this->CalidadConstruccions->patchEntity($calidadConstruccion, $this->request->getData());
            if ($this->CalidadConstruccions->save($calidadConstruccion)) {
                $this->Flash->success(__('The calidad construccion has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The calidad construccion could not be saved. Please, try again.'));
        }
        $this->set(compact('calidadConstruccion'));
    }

    /**
     * Edit method
     *
     * @param string|null $id Calidad Construccion id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $calidadConstruccion = $this->CalidadConstruccions->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $calidadConstruccion = $this->CalidadConstruccions->patchEntity($calidadConstruccion, $this->request->getData());
            if ($this->CalidadConstruccions->save($calidadConstruccion)) {
                $this->Flash->success(__('The calidad construccion has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The calidad construccion could not be saved. Please, try again.'));
        }
        $this->set(compact('calidadConstruccion'));
    }

    /**
     * Delete method
     *
     * @param string|null $id Calidad Construccion id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $calidadConstruccion = $this->CalidadConstruccions->get($id);
        if ($this->CalidadConstruccions->delete($calidadConstruccion)) {
            $this->Flash->success(__('The calidad construccion has been deleted.'));
        } else {
            $this->Flash->error(__('The calidad construccion could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
