<?php
namespace App\Controller;

use App\Controller\AppController;

/**
 * CambioVolantes Controller
 *
 * @property \App\Model\Table\CambioVolantesTable $CambioVolantes
 *
 * @method \App\Model\Entity\CambioVolante[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class CambioVolantesController extends AppController
{

    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        $cambioVolantes = $this->paginate($this->CambioVolantes);

        $this->set(compact('cambioVolantes'));
    }


    public function busqueda()
    {
$cambioVolantes = $this->paginate($this->CambioVolantes);

$this->set(compact('cambioVolantes'));

    }

    /**
     * View method
     *
     * @param string|null $id Cambio Volante id.
     * @return \Cake\Http\Response|void
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $cambioVolante = $this->CambioVolantes->get($id, [
            'contain' => []
        ]);

        $this->set('cambioVolante', $cambioVolante);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $cambioVolante = $this->CambioVolantes->newEntity();
        if ($this->request->is('post')) {
            $cambioVolante = $this->CambioVolantes->patchEntity($cambioVolante, $this->request->getData());
            if ($this->CambioVolantes->save($cambioVolante)) {
                $this->Flash->success(__('The cambio volante has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The cambio volante could not be saved. Please, try again.'));
        }
        $this->set(compact('cambioVolante'));
    }

    /**
     * Edit method
     *
     * @param string|null $id Cambio Volante id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $cambioVolante = $this->CambioVolantes->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $cambioVolante = $this->CambioVolantes->patchEntity($cambioVolante, $this->request->getData());
            if ($this->CambioVolantes->save($cambioVolante)) {
                $this->Flash->success(__('The cambio volante has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The cambio volante could not be saved. Please, try again.'));
        }
        $this->set(compact('cambioVolante'));
    }

    /**
     * Delete method
     *
     * @param string|null $id Cambio Volante id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $cambioVolante = $this->CambioVolantes->get($id);
        if ($this->CambioVolantes->delete($cambioVolante)) {
            $this->Flash->success(__('The cambio volante has been deleted.'));
        } else {
            $this->Flash->error(__('The cambio volante could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }



    public function resultado(){
        $search = null;
            if(!empty($this->request->query['search'])){
                $search = $this->request->query['search'];
                $search = preg_replace('/[^a-zA-ZñÑáéíóúÁÉÍÓÚ0-9 ]/', '', $search);
                $terms = explode(' ', trim($search));
                $terms = array_diff($terms, array(''));
                           
                foreach($terms as $term){
                    $terms1[] = preg_replace('/[^a-zA-ZñÑáéíóúÁÉÍÓÚ0-9 ]/', '', $term);
                    $conditions[] = array(
                                    'chasis LIKE' => '%' . $term . '%'
                    );
                }
                $stocks = $this->CambioVolantes->find('all', array('recursive' => -1, 'conditions' => $conditions, 'limit' => 200, 'order' => ['id' => 'asc']));
                
                $this->set('cambioVolantes', $stocks);
              if($this->request->is('ajax')){
                  $this->layout = true;
                  $this->set('ajax', 1);
              }else{
                  $this->set('ajax', 0);
              }
        } else {
             return $this->redirect(['action' => 'busqueda']);
        }
    }


}
