<?php
namespace App\Controller;

use App\Controller\AppController;
use Cake\ORM\TableRegistry ; 
use Cake\Datasource\ConnectionManager;

/**
 * Cambioprecios Controller
 *
 * @property \App\Model\Table\CambiopreciosTable $Cambioprecios
 *
 * @method \App\Model\Entity\Cambioprecio[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class CambiopreciosController extends AppController
{

    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        $this->paginate = [
            'contain' => ['Stocks']
        ];
        $cambioprecios = $this->paginate($this->Cambioprecios);

        $this->set(compact('cambioprecios'));
    }

    /**
     * View method
     *
     * @param string|null $id Cambioprecio id.
     * @return \Cake\Http\Response|void
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $cambioprecio = $this->Cambioprecios->get($id, [
            'contain' => ['Stocks']
        ]);

        $this->set('cambioprecio', $cambioprecio);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add($idvehiculo = null)
    {
        $cambioprecio = $this->Cambioprecios->newEntity();
        if ($this->request->is('post')) {
            $cambioprecio = $this->Cambioprecios->patchEntity($cambioprecio, $this->request->getData()); 
            $modeltable = TableRegistry::get('stocks');
            $stocks = $modeltable->get($idvehiculo);
            $hoy = getdate(); 
            $fecha = $hoy['mday']."/".$hoy['mon']."/".$hoy['year'];
            $cambioprecio->stock_id = $idvehiculo;
            $cambioprecio->chasis = trim($stocks->chasis);
            $cambioprecio->fecha = $fecha;
            $cambioprecio->estado = 0;
            $cambioprecio->empleado = $this->Auth->User('id');
            
            if ($this->Cambioprecios->save($cambioprecio)) {

                if($cambioprecio->precioautomatico == 1){
                    $connection = ConnectionManager::get('default');
                    $connection->execute('update productos set pro_entrega = ?, pro_mostrarprecio=?, pro_formadeventa=? where pro_codigo = ?', [$cambioprecio->entregaminima, 1, $cambioprecio->formadeventa, $idvehiculo ]);
                    $connection->commit();
                    $connection->disconnect();

                }else{
                    if($cambioprecio->precioautomatico == 2){
                        $connection = ConnectionManager::get('default');
                        $connection->execute('update productos set pro_entrega = ?, pro_newcontado=?, pro_newcontado3meses=?, pro_newmeses12=?, pro_newmeses18=?, pro_newmeses36=?, pro_mostrarprecio=?, pro_formadeventa=? where pro_codigo = ?', [$cambioprecio->entregaminima, $cambioprecio->contado , $cambioprecio->contado3meses, $cambioprecio->meses12, $cambioprecio->meses18, $cambioprecio->meses36, 2, $cambioprecio->formadeventa, $idvehiculo ]);
                        $connection->commit();
                        $connection->disconnect();
                    }else{
                        $connection = ConnectionManager::get('default');
                        $connection->execute('update productos set pro_entrega = ?, pro_newcontado=?, pro_newcontado3meses=?, pro_newmeses12=?, pro_newmeses18=?, pro_newmeses36=?, pro_mostrarprecio=?, pro_formadeventa=?, pro_totalcompra=? where pro_codigo = ?', [$cambioprecio->entregaminima, $cambioprecio->contado , $cambioprecio->contado3meses, $cambioprecio->meses12, $cambioprecio->meses18, $cambioprecio->meses36, 3, $cambioprecio->formadeventa, $cambioprecio->costo, $idvehiculo ]);
                        $connection->commit();
                        $connection->disconnect();
                    }
                }

                $this->Flash->success(__('Precio cambiado con exito!'));
               echo "<script>history.go(-2)</script>";
            }
            
        }
        $stocks = $this->Cambioprecios->Stocks->get($idvehiculo);
      // $this->Flash->success($stocks);
        $cambioprecio->stock_id = $idvehiculo;
        
        $cambioprecio->chasis = trim($stocks->chasis);
        $cambioprecio->entregaminima = $stocks->entregaminima;
        $cambioprecio->contado = 0;
        $cambioprecio->contado3meses = 0;
        $cambioprecio->meses12 = 0;
        $cambioprecio->meses18 = 0;
        $cambioprecio->meses36 = 0;


        $admini  =  TableRegistry::get('administrador_precios');
        $query = $admini->get(1);
        $this->set('administradorPrecio', $query);  

        $Comisiones = TableRegistry::get('comisiones');
        $comision = $Comisiones->get(1);
        $tocks  =  TableRegistry::get('cotizacions');
        $query = $tocks->find('all');
        $venta = 0;
        $compra = 0;
        foreach ($query as $coti):
          $venta = $coti->doven;
          $compra = $coti->docom;
        endforeach;

        $this->set('cotiventa', $venta);
        $this->set('coticompra', $compra);

        
        $this->set(compact('cambioprecio', 'stocks'));
    }

    /**
     * Edit method
     *
     * @param string|null $id Cambioprecio id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $cambioprecio = $this->Cambioprecios->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $cambioprecio = $this->Cambioprecios->patchEntity($cambioprecio, $this->request->getData());
            if ($this->Cambioprecios->save($cambioprecio)) {
                $this->Flash->success(__('The cambioprecio has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The cambioprecio could not be saved. Please, try again.'));
        }
        $stocks = $this->Cambioprecios->Stocks->find('list', ['limit' => 200]);
        $this->set(compact('cambioprecio', 'stocks'));
    }

    /**
     * Delete method
     *
     * @param string|null $id Cambioprecio id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $cambioprecio = $this->Cambioprecios->get($id);
        if ($this->Cambioprecios->delete($cambioprecio)) {
            $this->Flash->success(__('The cambioprecio has been deleted.'));
        } else {
            $this->Flash->error(__('The cambioprecio could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
