<?php
namespace App\Controller;

use App\Controller\AppController;

/**
 * Comisiones Controller
 *
 * @property \App\Model\Table\ComisionesTable $Comisiones
 *
 * @method \App\Model\Entity\Comisione[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class ComisionesController extends AppController
{

    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        $comisiones = $this->paginate($this->Comisiones);

        $this->set(compact('comisiones'));
    }

    /**
     * View method
     *
     * @param string|null $id Comisione id.
     * @return \Cake\Http\Response|void
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $comisione = $this->Comisiones->get($id, [
            'contain' => []
        ]);

        $this->set('comisione', $comisione);
    }


    public function vendedores($id = null)
    {
        $comisione = $this->Comisiones->get($id, [
            'contain' => []
        ]);

        $this->set('comisione', $comisione);
    }

    public function gerentes($id = null)
    {
        $comisione = $this->Comisiones->get($id, [
            'contain' => []
        ]);

        $this->set('comisione', $comisione);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $comisione = $this->Comisiones->newEntity();
        if ($this->request->is('post')) {
            $comisione = $this->Comisiones->patchEntity($comisione, $this->request->getData());
            if ($this->Comisiones->save($comisione)) {
                $this->Flash->success(__('The comisione has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The comisione could not be saved. Please, try again.'));
        }
        
        $this->set(compact('comisione' ));
    }

    /**
     * Edit method
     *
     * @param string|null $id Comisione id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $comisione = $this->Comisiones->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $comisione = $this->Comisiones->patchEntity($comisione, $this->request->getData());
            if ($this->Comisiones->save($comisione)) {
                $this->Flash->success(__('MODIFICADO CORRECTAMENTE'));

                return $this->redirect(['action' => 'view/1']);
            }
            $this->Flash->error(__('The comisione could not be saved. Please, try again.'));
        }
        
        $this->set(compact('comisione' ));
    }

    public function editgerente($id = null)
    {
        $comisione = $this->Comisiones->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $comisione = $this->Comisiones->patchEntity($comisione, $this->request->getData());
            if ($this->Comisiones->save($comisione)) {
                $this->Flash->success(__('MODIFICADO CORRECTAMENTE'));

                return $this->redirect(['action' => 'view/1']);
            }
            $this->Flash->error(__('The comisione could not be saved. Please, try again.'));
        }
        
        $this->set(compact('comisione' ));
    }

    /**
     * Delete method
     *
     * @param string|null $id Comisione id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $comisione = $this->Comisiones->get($id);
        if ($this->Comisiones->delete($comisione)) {
            $this->Flash->success(__('The comisione has been deleted.'));
        } else {
            $this->Flash->error(__('The comisione could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
