<?php
namespace App\Controller;

use App\Controller\AppController;

/**
 * Cotizaciones Controller
 *
 * @property \App\Model\Table\CotizacionesTable $Cotizaciones
 *
 * @method \App\Model\Entity\Cotizacione[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class CotizacionesController extends AppController
{

    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        $cotizaciones = $this->paginate($this->Cotizaciones);

        $this->set(compact('cotizaciones'));
    }

    /**
     * View method
     *
     * @param string|null $id Cotizacione id.
     * @return \Cake\Http\Response|void
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $cotizacione = $this->Cotizaciones->get($id, [
            'contain' => []
        ]);

        $this->set('cotizacione', $cotizacione);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $cotizacione = $this->Cotizaciones->newEntity();
        if ($this->request->is('post')) {
            $cotizacione = $this->Cotizaciones->patchEntity($cotizacione, $this->request->getData());
            if ($this->Cotizaciones->save($cotizacione)) {
                $this->Flash->success(__('The cotizacione has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The cotizacione could not be saved. Please, try again.'));
        }
        $this->set(compact('cotizacione'));
    }

    /**
     * Edit method
     *
     * @param string|null $id Cotizacione id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $cotizacione = $this->Cotizaciones->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $cotizacione = $this->Cotizaciones->patchEntity($cotizacione, $this->request->getData());
            if ($this->Cotizaciones->save($cotizacione)) {
                $this->Flash->success(__('The cotizacione has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The cotizacione could not be saved. Please, try again.'));
        }
        $this->set(compact('cotizacione'));
    }

    /**
     * Delete method
     *
     * @param string|null $id Cotizacione id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $cotizacione = $this->Cotizaciones->get($id);
        if ($this->Cotizaciones->delete($cotizacione)) {
            $this->Flash->success(__('The cotizacione has been deleted.'));
        } else {
            $this->Flash->error(__('The cotizacione could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
