<?php
namespace App\Controller;

use App\Controller\AppController;
use Cake\ORM\TableRegistry ; 
use Cake\Datasource\ConnectionManager;

/**
 * Generarcomisions Controller
 *
 * @property \App\Model\Table\GenerarcomisionsTable $Generarcomisions
 *
 * @method \App\Model\Entity\Generarcomision[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class GenerarcomisionsController extends AppController
{

    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        $generarcomisions = $this->paginate($this->Generarcomisions);

        $this->set(compact('generarcomisions'));
    }

    /**
     * View method
     *
     * @param string|null $id Generarcomision id.
     * @return \Cake\Http\Response|void
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function generar($id = null)
    {
        $generarcomision = $this->Generarcomisions->get($id, [
            'contain' => []
        ]);

        if($generarcomision->id > 0){
            $connection = ConnectionManager::get('default');
            $connection->execute('INSERT INTO chaperias( fecha, empleado, usuarioapp, chasis, monto, cantidadpieza,  total, entrega, estado, observacion) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)', [ $generarcomision->fechaultimaentrega, 6, 48, 'COMISION CHAPERIA', $generarcomision->suma, 1, $generarcomision->suma, 0, 1, 'COMISION DE NESTOR']);
            $connection->execute('UPDATE chaperias SET estadocomision=? WHERE fechaultimaentrega = ?', [1, $generarcomision->fechaultimaentrega]);
                
            $connection->commit();
            $connection->disconnect();
            $this->Flash->success(__('Generado con exitos!'));

            return $this->redirect(['action' => 'index']);
        }
        

        $this->set('generarcomision', $generarcomision);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $generarcomision = $this->Generarcomisions->newEntity();
        if ($this->request->is('post')) {
            $generarcomision = $this->Generarcomisions->patchEntity($generarcomision, $this->request->getData());
            if ($this->Generarcomisions->save($generarcomision)) {
                $this->Flash->success(__('The generarcomision has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The generarcomision could not be saved. Please, try again.'));
        }
        $this->set(compact('generarcomision'));
    }

    /**
     * Edit method
     *
     * @param string|null $id Generarcomision id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $generarcomision = $this->Generarcomisions->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $generarcomision = $this->Generarcomisions->patchEntity($generarcomision, $this->request->getData());
            if ($this->Generarcomisions->save($generarcomision)) {
                $this->Flash->success(__('The generarcomision has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The generarcomision could not be saved. Please, try again.'));
        }
        $this->set(compact('generarcomision'));
    }

    /**
     * Delete method
     *
     * @param string|null $id Generarcomision id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $generarcomision = $this->Generarcomisions->get($id);
        if ($this->Generarcomisions->delete($generarcomision)) {
            $this->Flash->success(__('The generarcomision has been deleted.'));
        } else {
            $this->Flash->error(__('The generarcomision could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
