<?php

namespace App\Controller;

use App\Controller\AppController;
use Cake\ORM\TableRegistry;
use Cake\Datasource\ConnectionManager;
use Intervention\Image\ImageManagerStatic as Image;

class ImagenappsController extends AppController
{
    public function index()
    {
        $imagenapps = $this->paginate($this->Imagenapps);
        $this->set(compact('imagenapps'));
    }

    public function index3()
    {
        $conditions = ['manual' => 1];
        $order = ['id' => 'desc'];

        if (!empty($this->request->getQuery('search'))) {
            $searchTerm = $this->request->getQuery('search');
            $conditions[] = ['chasis LIKE' => '%' . $searchTerm . '%'];
        }

        $this->paginate = [
            'conditions' => $conditions,
            'order' => $order,
            'limit' => 20 // Número de registros por página
        ];

        $imagenapps = $this->paginate($this->Imagenapps);

        $this->set(compact('imagenapps'));
    }

    public function aduana()
    {

        $search = null;
        if (!empty($this->request->query['search'])) {
            $search = $this->request->query['search'];

            $terms = explode(' ', trim($search));
            $terms = array_diff($terms, array(''));

            $suma = "";
            $numero = 0;
            foreach ($terms as $term) {

                $condi = "((upper(imagenapps.chasis) LIKE '%" . strtoupper($term) . "%' or upper(imagenapps.modelo) LIKE '%" . strtoupper($term) . "%' or upper(imagenapps.color) LIKE '%" . strtoupper($term) . "%' ) and imagenapps.manualactualizado = 0 AND imagenapps.manual = 1 AND stocktodos.chasis is null)";

                if ($numero == 0) {
                    $numero = 1;
                    $suma = $condi;
                } else {
                    $suma = $suma . ' and ' . $condi;
                }
            }

            $imagenapps = $this->Imagenapps->find()
                ->where($suma)
                ->join([
                    'stocktodos' => [
                        'table' => 'stocktodos',
                        'type' => 'LEFT',
                        'conditions' => ["imagenapps.chasis = REPLACE(stocktodos.chasis, '.', '')"]
                    ],
                ])->order(['imagenapps.chasis' => 'ASC']);

            $this->set('imagenapps', $this->paginate($imagenapps));
        } else {

            $this->set('search', '');
            $imagenapps = $this->Imagenapps->find()
                ->where(['imagenapps.manual = 1', 'stocktodos.chasis is null', 'imagenapps.manualactualizado = 0'])
                ->join([
                    'stocktodos' => [
                        'table' => 'stocktodos',
                        'type' => 'LEFT',
                        'conditions' => ["imagenapps.chasis = REPLACE(stocktodos.chasis, '.', '')"]
                    ],

                ])->order(['imagenapps.chasis' => 'ASC']);

            $this->set('imagenapps', $this->paginate($imagenapps));
            $this->set(compact('imagenapps'));
        }
    }

    public function index2()
    {

        $imagenapps = $this->Imagenapps->find(
            'all',
            array(
                'fields' => 'chasis',
                'group' => 'chasis'
            )
        );

        $this->set(compact('imagenapps'));
    }

    public function busqueda()
    {
        $search = null;
        if (!empty($this->request->query['search'])) {
            $search = $this->request->query['search'];
            $search = preg_replace('/[^a-zA-ZñÑáéíóúÁÉÍÓÚ0-9 -]/u', '', $search);
            $terms = explode(' ', trim($search));
            $terms = array_diff($terms, array(''));

            foreach ($terms as $term) {
                $terms1[] = preg_replace('/[^a-zA-ZñÑáéíóúÁÉÍÓÚ0-9 -]/u', '', $term);
                $conditions[] = array('UPPER(chasis) LIKE' => '%' . strtoupper($term) . '%');
            }
            $inventarios  =  TableRegistry::get('stocktodos');

            $query = $inventarios->find('all', array('recursive' => -1, 'conditions' => $conditions, 'limit' => 200, 'order' => ['id' => 'asc']));
            $terms1 = array_diff($terms1, array(''));
            $this->set(compact('search', 'terms1'));
            $this->set('imagenapps', $query);
            if ($query->count() > 0) {
            }
        } else {
            $this->set('search', '');
        }
    }

    public function view($id = null)
    {
        $imagenapp = $this->Imagenapps->get($id, [
            'contain' => []
        ]);

        $this->set('imagenapp', $imagenapp);
    }

    public function verinventario($id = null)
    {
        $imagenapp = $this->Imagenapps->get($id, [
            'contain' => []
        ]);

        $this->set('imagenapp', $imagenapp);
    }

    public function add($chasis = null)
    {
        $chasis = strtoupper($chasis);

        $imagens =  $this->Imagenapps->find();
        $imagens->where(['upper(chasis)' => '' . $chasis . '']);
        $this->set('imagen',  $imagens);
        //debug($imagens);

        $imagenapp = $this->Imagenapps->newEntity();
        if ($this->request->is('post')) {
            $imagenapp = $this->Imagenapps->patchEntity($imagenapp, $this->request->getData());

            $query = TableRegistry::get('imagenapps')->find();
            $query->select(['codigo' => $query->func()->max('codigo')]);
            $maximo = 0;
            foreach ($query as $imagenap) {
                // debug($imagenap->codigo+1);
                $maximo = $imagenap->codigo + 1;
            }

            $hoy = getdate();
            $imagenapp->fecha = $hoy['mday'] . "/" . $hoy['mon'] . "/" . $hoy['year'];
            $imagenapp->hora = $hoy['hours'] . ":" . $hoy['minutes'] . ":" . $hoy['seconds'];

            $imagenapp->imagen = $maximo . '.jpg';
            $imagenapp->codigo = $maximo;
            $imagenapp->chasis = $chasis;
            $image_name        = $maximo . '.jpg';
            $image_tmp         = $this->request->data['imagen']['tmp_name'];

            //move_uploaded_file($image_tmp, $destination);
            if (!empty($this->request->data['imagen']['tmp_name'])) {

                // luismoran: aqui insertar codigo para resamplear

                if (!move_uploaded_file($image_tmp, WWW_ROOT . 'img' . DS . 'chasis' . DS . $image_name)) {
                    $this->Flash->error('no se movio');
                }

                if ($this->Imagenapps->save($imagenapp)) {

                    $sql = "update productos set pro_imagenapp = (SELECT min(codigo) || '.jpg' FROM imagenapps where chasis = '" . $chasis . "') where pro_codori = '" . $chasis . "'";

                    $connection = ConnectionManager::get('default');
                    $connection->execute($sql);
                    $connection->commit();
                    $connection->disconnect();

                    //$this->Flash->success(__('The imagenapp has been saved.'));
                    //return $this->redirect(['action' => 'index']);
                    return $this->redirect($this->here);
                }
            }
            //$this->Flash->error(__('The imagenapp could not be saved. Please, try again.'));
        }
        $this->set(compact('imagenapp'));
    }

    public function add2($chasis = null)
    {
        $imagens =  $this->Imagenapps->find();
        $imagens->where(['chasis' => '' . $chasis . '']);
        $this->set('imagen',  $imagens);
        $imagenapp = $this->Imagenapps->newEntity();
        $this->set(compact('imagenapp'));
    }

    public function descargar($image_name)
    {
        $path = WWW_ROOT . 'img' . DS . 'chasis' . DS . $image_name;

        $params = array(
            'id' => $image_name,
            'name' => 'the name of the file as it should appear on the clients computer',
            'download' => true,
            'extension' => 'jpg',
            'path' => $path
        );
        debug($params);

        $this->set($params);
    }

    public function edit($id = null)
    {
        $imagenapp = $this->Imagenapps->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $imagenapp = $this->Imagenapps->patchEntity($imagenapp, $this->request->getData());
            if ($this->Imagenapps->save($imagenapp)) {
                $this->Flash->success(__('The imagenapp has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The imagenapp could not be saved. Please, try again.'));
        }
        $this->set(compact('imagenapp'));
    }

    public function modichasis($id = null)
    {
        $imagenapp = $this->Imagenapps->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $imagenapp = $this->Imagenapps->patchEntity($imagenapp, $this->request->getData());
            if ($this->Imagenapps->save($imagenapp)) {
                $this->Flash->success(__('Guardado con exito.'));

                return $this->redirect(['action' => 'index3']);
            }
            $this->Flash->error(__('No se pudo guardar. Intente nuevamente.'));
        }
        $this->set(compact('imagenapp'));
    }

    public function delete($id = null, $chasis)
    {
        $this->request->allowMethod(['post', 'delete']);
        $imagenapp = $this->Imagenapps->get($id);
        if ($this->Imagenapps->delete($imagenapp)) {

            $query = $this->Imagenapps->find('all', ['conditions' => [
                'chasis' =>  trim($chasis)
            ]]);

            if ($query->count() == 0) {
                $connection = ConnectionManager::get('default');
                $connection->execute('UPDATE productos SET pro_imagenapp = ? WHERE pro_codigo = ?', ['*', $chasis]);
                $connection->commit();
                $connection->disconnect();
                return $this->redirect(['action' => 'add/' . $chasis]);
            }

            return $this->redirect(['action' => 'add/' . $chasis]);
        }
    }

    public function delete2($id = null, $chasis)
    {
        $this->request->allowMethod(['post', 'delete']);
        $imagenapp = $this->Imagenapps->get($id);
        if ($this->Imagenapps->delete($imagenapp)) {

            $query = $this->Imagenapps->find('all', ['conditions' => [
                'chasis' =>  trim($chasis)
            ]]);

            if ($query->count() == 0) {
                $connection = ConnectionManager::get('default');
                $connection->execute('UPDATE productos SET pro_imagenapp = ? WHERE pro_codori = ?', ['*', $chasis]);
                $connection->commit();
                $connection->disconnect();
            }

            echo "<script>history.go(-2)</script>";
        }
    }

    public function esdeportivo($chasis = null, $bus = null)
    {
        $connection = ConnectionManager::get('default');
        $connection->execute('UPDATE productos SET pro_deportivo = ? WHERE pro_codigo = ?', [1, $chasis]);
        $connection->commit();
        $connection->disconnect();

        return $this->redirect(['action' => 'busqueda?search=' . $bus]);
    }

    public function nodeportivo($chasis = null, $bus = null)
    {
        $connection = ConnectionManager::get('default');
        $connection->execute('UPDATE productos SET pro_deportivo = ? WHERE pro_codigo = ?', [0, $chasis]);
        $connection->commit();
        $connection->disconnect();

        return $this->redirect(['action' => 'busqueda?search=' . $bus]);
    }

    public function esllanta($chasis = null, $bus = null)
    {
        $connection = ConnectionManager::get('default');
        $connection->execute('UPDATE productos SET pro_llanta = ? WHERE pro_codigo = ?', [1, $chasis]);
        $connection->commit();
        $connection->disconnect();

        return $this->redirect(['action' => 'busqueda?search=' . $bus]);
    }

    public function nollanta($chasis = null, $bus = null)
    {
        $connection = ConnectionManager::get('default');
        $connection->execute('UPDATE productos SET pro_llanta = ? WHERE pro_codigo = ?', [0, $chasis]);
        $connection->commit();
        $connection->disconnect();

        return $this->redirect(['action' => 'busqueda?search=' . $bus]);
    }

    public function quitarfotos($chasis = null, $bus = null)
    {
        $connection = ConnectionManager::get('default');
        $connection->execute('UPDATE imagenapps SET mostrar = ? WHERE chasis = ?', [1, $chasis]);
        $connection->execute('UPDATE productos SET pro_imagenapp = ? WHERE pro_codori = ?', ['', $chasis]);
        $connection->commit();
        $connection->disconnect();

        return $this->redirect(['action' => 'busqueda?search=' . $bus]);
    }

    public function borrarfotos()
    {
        /*  $files = glob(WWW_ROOT . 'img' . DS . 'chasis' . '/*.jpg'); //obtenemos todos los nombres de los ficheros
        foreach ($files as $file) {
            if (is_file($file)) {
                $nombre = str_replace('/home/hvnimportaciones/public_html/app/webroot/img/chasis/', '', $file);
                $imagens =  $this->Imagenapps->find();
                $imagens->where(['imagen' => '' . $nombre . '', 'fechaventa' => '1']);
                if ($imagens->count() == 0) {
                    unlink($file);
                    // print_r($nombre);
                }
            }
        }*/
    }

    public function addvarios($chasis = null)
    {
        if (
            $this->Auth->User("id") == 1 or //richard
            $this->Auth->User("id") == 2 or //oscar
            $this->Auth->User("id") == 3 or //sergio
            $this->Auth->User("id") == 31 or //german
            $this->Auth->User("id") == 130 or //martha
            $this->Auth->User("id") == 694 or // luism
            $this->Auth->User("id") == 781 or // jose
            $this->Auth->User("id") == 701            
        ) {
            $chasis = strtoupper($chasis);

            $imagens =  $this->Imagenapps->find();
            $imagens->where(['upper(chasis)' => '' . $chasis . '']);
            $this->set('imagen',  $imagens);

            $imagenapp = $this->Imagenapps->newEntity();
            if ($this->request->is('post')) {
                //debug($this->request->getData(["archivo"]['tmp_name'])); 
                $query = TableRegistry::get('imagenapps')->find();
                $query->select(['codigo' => $query->func()->max('codigo')]);
                $maximo = 0;
                foreach ($query as $imagenap) {
                    $maximo = $imagenap->codigo + 1;
                }
                foreach ($this->request->getData(["archivo"]['tmp_name']) as $imagenv) {
                    $max = sizeof($imagenv);
                    for ($i = 0; $i < $max; $i++) {

                        $hoy = getdate();
                        $imagenapp = $this->Imagenapps->newEntity();
                        $imagenapp->fecha = $hoy['mday'] . "/" . $hoy['mon'] . "/" . $hoy['year'];
                        $imagenapp->hora = $hoy['hours'] . ":" . $hoy['minutes'] . ":" . $hoy['seconds'];

                        $imagenapp->imagen = $maximo . '.jpg';
                        $imagenapp->codigo = $maximo;
                        $imagenapp->chasis = $chasis;
                        $image_name        = $maximo . '.jpg';
                        $image_tmp         = $imagenv[$i]['tmp_name'];

                        if (!empty($imagenv[$i]['tmp_name'])) {
                            //  if (! move_uploaded_file($image_tmp , WWW_ROOT . 'img' . DS . 'chasis' . DS . $image_name)){
                            //     $this->Flash->error('no se movio');
                            // }  if (!$this->compressImage($image_tmp, WWW_ROOT . 'img' . DS . 'chasis' . DS . $image_name, 30)) {

                            if (!$this->compressImage($image_tmp, WWW_ROOT . 'img' . DS . 'chasis' . DS . $image_name, 30)) {
                                // if (!move_uploaded_file($image_tmp , WWW_ROOT . 'img' . DS . 'chasis' . DS . $image_name)){

                                //aca generar el resample


                                $this->Flash->error('no se movio');
                            } else {

                                if ($this->Imagenapps->save($imagenapp)) {
                                    $sql = "update productos set pro_imagenapp = (SELECT min(codigo) || '.jpg' FROM imagenapps where chasis = '" . $chasis . "') where pro_codori = '" . $chasis . "'";
                                    $sql2 = "UPDATE public.inventarios set imagen = (SELECT min(codigo) || '.jpg' FROM imagenapps where UPPER(chasis) = '" . strtoupper($chasis) . "') where UPPER(chasis) = '" . strtoupper($chasis) . "'";

                                    $connection = ConnectionManager::get('default');
                                    $connection->execute($sql);
                                    $connection->execute($sql2);

                                    $connection->commit();
                                    $connection->disconnect();
                                }
                            }
                        }
                        $maximo++;
                    }
                }
                //return $this->redirect($this->here);
            }
            $this->set(compact('imagenapp'));
        } else {
            return $this->redirect(['controller' => 'Users', 'action' => 'home']);
        }
    }


    public function varios($chasis = null)
    {
        if (
            $this->Auth->User("id") == 1 or //richard
            $this->Auth->User("id") == 2 or //oscar
            $this->Auth->User("id") == 3 or //sergio
            $this->Auth->User("id") == 31 or //german
            $this->Auth->User("id") == 130 or //martha
            $this->Auth->User("id") == 6940 // luism            
        ) {
            $chasis = strtoupper($chasis);
            $imagens =  $this->Imagenapps->find();
            $imagens->where(['upper(chasis)' => '' . $chasis . '']);
            $this->set('imagen',  $imagens);

            $imagenapp = $this->Imagenapps->newEntity();
            if ($this->request->is('post')) {

                foreach ($this->request->getData(["archivo"]['tmp_name']) as $imagenv) {

                    for ($i = 0; $i < sizeof($imagenv); $i++) {
                        $compressed_image = Image::make($imagenv[$i]);
                    }
                }
                //return $this->redirect($this->here);
            }
            $this->set(compact('imagenapp'));
        } else {
            return $this->redirect(['controller' => 'Users', 'action' => 'home']);
        }
    }

    public function compressImage($source, $destination, $quality)
    {
        // Obtenemos la información de la imagen
        $imgInfo = getimagesize($source);
        $mime = $imgInfo['mime'];

        // Creamos una imagen

        switch ($mime) {
            case 'image/jpeg':
                $image = imagecreatefromjpeg($source);
                break;
            case 'image/png':
                $image = imagecreatefrompng($source);
                break;
            case 'image/gif':
                $image = imagecreatefromgif($source);
                break;
            default:
                $image = imagecreatefromjpeg($source);
        }

        if ((((filesize($source) / 1024) / 1024)) > 5) {
            $quality = 10;
        }

        if ((((filesize($source) / 1024) / 1024)) > 4 &&  (((filesize($source) / 1024) / 1024)) < 5) {
            $quality = 15;
        }

        if ((((filesize($source) / 1024) / 1024)) > 3 && (((filesize($source) / 1024) / 1024)) < 4) {
            $quality = 20;
        }

        if ((((filesize($source) / 1024) / 1024)) > 2 &&  (((filesize($source) / 1024) / 1024)) < 3) {
            $quality = 22;
        }


        if ((((filesize($source) / 1024) / 1024)) > 1 &&  (((filesize($source) / 1024) / 1024)) < 2) {
            $quality = 25;
        }

        // Guardamos la imagen
        imagejpeg($image, $destination, $quality);

        // Devolvemos la imagen comprimida
        return $destination;
    }

    public function addchasis()
    {

        $imagenapp = $this->Imagenapps->newEntity();
        $datos = $this->Imagenapps->newEntity();
        if ($this->request->is('post')) {
            $imagenapp = $this->Imagenapps->patchEntity($imagenapp, $this->request->getData());

            $datos = $imagenapp;

            $query = TableRegistry::get('imagenapps')->find();
            $query->select(['codigo' => $query->func()->max('codigo')]);
            $maximo = 0;
            foreach ($query as $imagenap) {
                $maximo = $imagenap->codigo + 1;
            }

            $chasis = $imagenapp->chasis;
            $marca = $imagenapp->marca;
            $modelo = $imagenapp->modelo;
            $color = $imagenapp->color;


            foreach ($this->request->getData(["archivo"]['tmp_name']) as $imagenv) {
                $max = sizeof($imagenv);
                for ($i = 0; $i < $max; $i++) {

                    $hoy = getdate();

                    $imagenapp = $this->Imagenapps->newEntity();
                    if ($i == 0) {

                        $imagenapp->manual = 1;

                        $imagenapp->marca = $marca;
                        $imagenapp->modelo = $modelo;
                        $imagenapp->color = $color;

                        $imagenapp->radio = $datos->radio;
                        $imagenapp->auxilio = $datos->auxilio;
                        $imagenapp->llavederueda = $datos->llavederueda;
                        $imagenapp->manija = $datos->manija;
                        $imagenapp->antena = $datos->antena;
                        $imagenapp->senaleritos = $datos->senaleritos;
                        $imagenapp->tapallanta = $datos->tapallanta;
                        $imagenapp->observacion = $datos->observacion;
                    }
                    $imagenapp->fecha = $hoy['mday'] . "/" . $hoy['mon'] . "/" . $hoy['year'];
                    $imagenapp->hora = $hoy['hours'] . ":" . $hoy['minutes'] . ":" . $hoy['seconds'];

                    $imagenapp->imagen = $maximo . '.jpg';
                    $imagenapp->codigo = $maximo;
                    $imagenapp->chasis = $chasis;
                    $image_name        = $maximo . '.jpg';
                    $image_tmp         = $imagenv[$i]['tmp_name'];

                    if (!empty($imagenv[$i]['tmp_name'])) {
                        if (!move_uploaded_file($image_tmp, WWW_ROOT . 'img' . DS . 'chasis' . DS . $image_name)) {
                            $this->Flash->error('no se movio');
                        }

                        if ($this->Imagenapps->save($imagenapp)) {
                            $sql = "update productos set pro_imagenapp = (SELECT min(codigo) || '.jpg' FROM imagenapps where chasis = '" . $chasis . "') where pro_codori = '" . $chasis . "'";
                            $connection = ConnectionManager::get('default');
                            $connection->execute($sql);
                            $connection->commit();
                            $connection->disconnect();
                        }
                    }
                    $maximo++;
                }
            }
            return $this->redirect(['action' => 'busqueda']);
        }
        $this->set(compact('imagenapp'));
    }

    public function secuestrado($chasis = null, $bus = null)
    {
        $connection = ConnectionManager::get('default');
        $connection->execute('UPDATE productos SET pro_secuestrado = ? WHERE pro_codigo = ?', [1, $chasis]);
        $connection->commit();
        $connection->disconnect();

        echo "<script>history.go(-1)</script>";
    }

    public function nosecuestrado($chasis = null, $bus = null)
    {
        $connection = ConnectionManager::get('default');
        $connection->execute('UPDATE productos SET pro_secuestrado = ? WHERE pro_codigo = ?', [0, $chasis]);
        $connection->commit();
        $connection->disconnect();

        echo "<script>history.go(-1)</script>";
    }

    public function editar($chasis = null)
    {
        $imagenapp = $this->Imagenapps->newEntity();
        $imagenapp->chasis = $chasis;
        if ($this->request->is(['patch', 'post', 'put'])) {
            $imagenapp = $this->Imagenapps->patchEntity($imagenapp, $this->request->getData());

            $connection = ConnectionManager::get('default');
            $connection->execute('UPDATE imagenapps SET chasis=? WHERE chasis=?', [$imagenapp->chasis, $chasis]);
            $connection->commit();
            $connection->disconnect();

            echo "<script>history.go(-1)</script>";
        }
        $this->set(compact('imagenapp'));
    }
}
