<?php
namespace App\Controller;

use App\Controller\AppController;

/**
 * InventariosUsados Controller
 *
 * @property \App\Model\Table\InventariosUsadosTable $InventariosUsados
 *
 * @method \App\Model\Entity\InventariosUsado[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class InventariosUsadosController extends AppController
{

    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {

        $search = null;
        if(!empty($this->request->query['search'])){
            $search = $this->request->query['search'];
            $search = preg_replace('/[^a-zA-ZñÑáéíóúÁÉÍÓÚ0-9 ]/', '', $search);
            $terms = explode(' ', trim($search));
            $terms = array_diff($terms, array(''));
            foreach($terms as $term){
                $terms1[] = preg_replace('/[^a-zA-ZñÑáéíóúÁÉÍÓÚ0-9 ]/', '', $term);
                $conditions[] =  array('estado = 0 and chasis ILIKE' => '%' . $term . '%');
            }
            $inventariosUsados = $this->InventariosUsados->find('all', array('recursive' => -1, 'conditions' => $conditions, 'limit' => 200, 'order' => ['id' => 'asc']));
            $terms1 = array_diff($terms1, array(''));
            $this->set(compact('inventariosUsados', 'terms1'));
        } else {
            $inventariosUsados = $this->paginate($this->InventariosUsados, ['conditions' => 'estado = 0',  'order' => [ 'id' => 'desc']]);
            $this->set(compact('inventariosUsados'));
        }

        
    }

    /**
     * View method
     *
     * @param string|null $id Inventarios Usado id.
     * @return \Cake\Http\Response|void
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $inventariosUsado = $this->InventariosUsados->get($id, [
            'contain' => []
        ]);

        $this->set('inventariosUsado', $inventariosUsado);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $inventariosUsado = $this->InventariosUsados->newEntity();
        if ($this->request->is('post')) {
            $inventariosUsado = $this->InventariosUsados->patchEntity($inventariosUsado, $this->request->getData());
            $hoy = getdate(); 
             $fecha = $hoy['mday']."/".$hoy['mon']."/".$hoy['year'];
             $inventariosUsado->fecha = $fecha;
             $inventariosUsado->usuario = $this->Auth->User('id');
        

            if ($this->InventariosUsados->save($inventariosUsado)) {
                $this->Flash->success(__('The inventarios usado has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The inventarios usado could not be saved. Please, try again.'));
        }
        $this->set(compact('inventariosUsado'));
    }


    public function addother($id = null)
    {
        $inventariosUsado = $this->InventariosUsados->newEntity();
        if ($this->request->is('post')) {

            $inventariosUsadoOriginal = $this->InventariosUsados->newEntity();
            $inventariosUsadoOriginal = $this->InventariosUsados->get($id);
            

             $inventariosUsado = $this->InventariosUsados->patchEntity($inventariosUsado, $this->request->getData());
             $hoy = getdate(); 
             $fecha = $hoy['mday']."/".$hoy['mon']."/".$hoy['year'];
             $inventariosUsado->fecha = $fecha;
             $inventariosUsado->usuario = $this->Auth->User('id');
             $inventariosUsado->estado = 1;

             $inventariosUsado->marca = $inventariosUsadoOriginal->marca;
             $inventariosUsado->modelo = $inventariosUsadoOriginal->modelo;
             $inventariosUsado->color = $inventariosUsadoOriginal->color;
             $inventariosUsado->chasis = $inventariosUsadoOriginal->chasis;
             $inventariosUsado->idprincipal = $id;
        
            echo $inventariosUsado;

            if ($this->InventariosUsados->save($inventariosUsado)) {
                $this->Flash->success(__('Guardado correctamente.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('Ocurrio un error'));
        }
        $this->set(compact('inventariosUsado'));
    }


    /**
     * Edit method
     *
     * @param string|null $id Inventarios Usado id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $inventariosUsado = $this->InventariosUsados->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $inventariosUsado = $this->InventariosUsados->patchEntity($inventariosUsado, $this->request->getData());
            if ($this->InventariosUsados->save($inventariosUsado)) {
                $this->Flash->success(__('The inventarios usado has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The inventarios usado could not be saved. Please, try again.'));
        }
        $this->set(compact('inventariosUsado'));
    }

    /**
     * Delete method
     *
     * @param string|null $id Inventarios Usado id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $inventariosUsado = $this->InventariosUsados->get($id);
        if ($this->InventariosUsados->delete($inventariosUsado)) {
            $this->Flash->success(__('The inventarios usado has been deleted.'));
        } else {
            $this->Flash->error(__('The inventarios usado could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
