<?php
namespace App\Controller;

use App\Controller\AppController;

/**
 * Listadodetalles Controller
 *
 * @property \App\Model\Table\ListadodetallesTable $Listadodetalles
 *
 * @method \App\Model\Entity\Listadodetalle[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class ListadodetallesController extends AppController
{
    /**
     * Index method
     *
     * @return \Cake\Http\Response|null
     */
    public function index()
    {
        $this->paginate = [
            'contain' => ['Liquisalarios'],
        ];
        $listadodetalles = $this->paginate($this->Listadodetalles);

        $this->set(compact('listadodetalles'));
    }

    /**
     * View method
     *
     * @param string|null $id Listadodetalle id.
     * @return \Cake\Http\Response|null
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $listadodetalle = $this->Listadodetalles->get($id, [
            'contain' => ['Liquisalarios'],
        ]);

        $this->set('listadodetalle', $listadodetalle);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $listadodetalle = $this->Listadodetalles->newEntity();
        if ($this->request->is('post')) {
            $listadodetalle = $this->Listadodetalles->patchEntity($listadodetalle, $this->request->getData());
            if ($this->Listadodetalles->save($listadodetalle)) {
                $this->Flash->success(__('The listadodetalle has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The listadodetalle could not be saved. Please, try again.'));
        }
        $liquisalarios = $this->Listadodetalles->Liquisalarios->find('list', ['limit' => 200]);
        $this->set(compact('listadodetalle', 'liquisalarios'));
    }

    /**
     * Edit method
     *
     * @param string|null $id Listadodetalle id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $listadodetalle = $this->Listadodetalles->get($id, [
            'contain' => [],
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $listadodetalle = $this->Listadodetalles->patchEntity($listadodetalle, $this->request->getData());
            if ($this->Listadodetalles->save($listadodetalle)) {
                $this->Flash->success(__('The listadodetalle has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The listadodetalle could not be saved. Please, try again.'));
        }
        $liquisalarios = $this->Listadodetalles->Liquisalarios->find('list', ['limit' => 200]);
        $this->set(compact('listadodetalle', 'liquisalarios'));
    }

    /**
     * Delete method
     *
     * @param string|null $id Listadodetalle id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $listadodetalle = $this->Listadodetalles->get($id);
        if ($this->Listadodetalles->delete($listadodetalle)) {
            $this->Flash->success(__('The listadodetalle has been deleted.'));
        } else {
            $this->Flash->error(__('The listadodetalle could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
