<?php

namespace App\Controller;

use App\Controller\AppController;

use Cake\Datasource\ConnectionManager;

use Cake\Datasource\Exception\RecordNotFoundException;


class Referencia2Controller extends AppController
{
  public function index()
  {

    $this->loadModel('Referencia2');

    $search = null;
    if (!empty($this->request->query['search'])) {
      $search = $this->request->query['search'];
      $search = preg_replace('/[^a-zA-ZñÑáéíóúÁÉÍÓÚ0-9 -]/u', '', $search);
      $terms = explode(' ', trim($search));
      $terms = array_diff($terms, array(''));

      foreach ($terms as $term) {

        $conditions[] = array(
          'AND' => array(
            'userid' => $this->Auth->User('id'),
            'borrado' => 0,
            'OR' => array(
              array('referencia2.cedula LIKE' => '%' . $term . '%'),
              array('referencia2.nombre LIKE' => '%' . strtoupper($term) . '%'),
              array('referencia2.apellido LIKE' => '%' . strtoupper($term) . '%'),
            )
          )
        );
      }
      $referencia2 = $this->Referencia2->find('all', array('recursive' => -1, 'conditions' => $conditions, 'limit' => 200, 'order' => ['Referencia2.id' => 'asc']));
      $this->set('referencia2', $this->paginate($referencia2));
      $this->set('_serialize', ['referencia2']);
    } else {
      $this->paginate = [
        'order' => [
          'Referencia2.id' => 'asc'
        ]
      ];

      $referencia2 = $this->paginate($this->Referencia2, [
        'conditions' => [
          'userid' => $this->Auth->User('id'),
          'borrado' => 0
        ]
      ]);

      $this->set(compact('referencia2'));
      $this->set('_serialize', ['referencia2']);
    }
    $this->set('search', $search);
  }

  public function add()
  {

    $this->loadModel('Referencia2');

    if ($this->request->is('post')) {

      $userid = ($_SESSION['Auth']['User']['id']);
      $referencia2 = $this->Referencia2->newEntity($this->request->getData());
      $referencia2->userid = $userid;
      $referencia2->fecha = date('d/m/y H:i:s');

      if ($this->Referencia2->save($referencia2)) {
        $this->Flash->success(__('Cliente registrado !'));
        return $this->redirect(['action' => 'index']);
      } else {
        $this->Flash->error(__('Error al guardar Cliente..'));
      }
    }
  }

  public function addref($id)
  {
    $this->loadModel('Referencia2documentos');

    if ($this->request->is('post')) {
      $userid = ($_SESSION['Auth']['User']['id']);
      $formData = $this->request->getData();
      $uploadFolder = 'img/docs';
      $uploadPath = WWW_ROOT . $uploadFolder . DS;

      $nombresvar = array(
        "fotocedula_frente" => "Foto Cédula (Frente)",
        "fotocedula_reverso" => "Foto Cédula (Reverso)",
        "certificado_de_matrimonio" => "Certificado de Matrimonio",
        "libreta_de_familia" => "Libreta de Familia",
        "certificado_de_nacimiento" => "Certificado de Nacimiento",
        "otro" => "Otro documento personal",
        "boleta_de_ande" => "Boleta de ANDE",
        "contrato_privado" => "Contrato Privado",
        "libreta_de_terreno" => "Libreta de Terreno",
        "titulo_de_propiedad" => "Título de Propiedad",
        "adjudicacion" => "Adjudicación",
        "certificado_de_trabajo" => "Certificado de Trabajo",
        "iva" => "I.V.A.",
        "patente" => "Patente",
        "extracto_bancario" => "Extracto Bancario",
        "factura_de_compra" => "Factura de Compra",
        "foto_del_comercio" => "Foto del Comercio",
        "foto_de_mercaderia" => "Foto de Mercadería",
        "otro_informal" => "Otro (Informal)",
        "maps_foto" => "Foto Google Maps",
        "casa_frente" => "Foto Casa (Frente)",
        "casa_lado_izquierdo" => "Foto Casa (lado izquierdo)",
        "casa_lado_derecho" => "Foto Casa (lado derecho)",
        "titular2_cedula_frente" => "Cédula Segundo Titular (Frente)",
        "titular2_cedula_reverso" => "Cédula Segundo Titular (Reverso)",
        "codeudor_cedula_frente" => "Cédula Codeudor (Frente)",
        "codeudor_cedula_reverso" => "Cédula Codeudor (Reverso)"
      );

      foreach ($nombresvar as $nombrevar => $titulovar) {
        ${$nombrevar} = $formData[$nombrevar];

        if (!empty(${$nombrevar}['tmp_name'])) {
          $filename = ${$nombrevar}['name'];
          $extension = pathinfo($filename, PATHINFO_EXTENSION);
          $bytes = random_bytes(16);
          $nombre_archivo = bin2hex($bytes);
          //$nombre_archivo = uniqid();
          $filenameup = $nombre_archivo . $userid . "." . $extension;

          if (move_uploaded_file(${$nombrevar}['tmp_name'], $uploadPath . $filenameup)) {
            $referencia2documento = $this->Referencia2documentos->newEntity($this->request->getData());
            $referencia2documento->id_referencia = $id;
            $referencia2documento->archivo = $filenameup;
            $referencia2documento->descripcion = $titulovar;

            if (!$this->Referencia2documentos->save($referencia2documento)) {
              $this->Flash->error(__("Error al guardar ({$nombrevar}).."));
            }
          } else {
            $this->Flash->error("Hubo un problema al cargar ({$nombrevar}). Inténtelo de nuevo.");
            return;
          }
        }
      }
      return $this->redirect(['action' => 'index']);
    }
  }

  public function view($id = null)
  {
    $this->loadModel('Referencia2');
    $this->loadModel('Referencia2documentos');

    $referencia = $this->Referencia2->get($id);
    $id_referencia = $referencia->id;
    $referencia2documentos = $this->Referencia2documentos->find()
      ->where(['id_referencia' => $id_referencia, 'borrado' => 0])
      ->all();

    if ($referencia->asignado_a > 0) {
      $connection = ConnectionManager::get('default');
      $sql = "select first_name||' '||last_name as funcionario from users where id=$referencia->asignado_a;";
      $stmt = $connection->execute($sql);
      $results = $stmt->fetchAll('assoc');
      $func = $results[0]['funcionario'];
    } else {
      $func = "*";
    }

    $this->set('referencia', $referencia);
    $this->set('referencia2documentos', $referencia2documentos);
    $this->set('func', $func);
    $this->set('_serialize', ['referencia', 'referencia2documentos']);
  }

  public function enviarcr($id = null)
  {
    $idreferencia = (int) $id;
    $this->loadModel('Referencia2');

    $referencia2 = $this->Referencia2->get($idreferencia);
    $referencia2->estado = 1;
    $referencia2->fecha_asignacion = date('d/m/y H:i:s');

    $connection = ConnectionManager::get('default');
    $sql = "select value from cycle_table where id = (select nextval('mi_secuencia'));";
    $stmt = $connection->execute($sql);
    $results = $stmt->fetchAll('assoc');
    $referencia2->asignado_a = $results[0]['value'];

    if ($this->Referencia2->save($referencia2)) {
      $this->Flash->success("Referencia actualizada y enviada a crédito.");
    } else {
      $this->Flash->error("Error al actualizar la referencia.");
    }
    return $this->redirect(['controller' => 'Referencia2', 'action' => 'index']);
  }

  public function aceptarcr()
  {

    $empleado = ($_SESSION['Auth']['User']['empleado']);
    $formData = $this->request->getData();
    $idreferencia = (int) $formData['id'];

    $this->loadModel('Referencia2');
    $this->loadModel('Clienteslocal');

    // recupera datos de la referencia
    $referencia2 = $this->Referencia2->get($idreferencia);
    $referencia2->estado = (int) $formData['estado'];
    $referencia2->resuelto_en = date('d/m/y H:i:s');
    $referencia2->obs = $formData['obs'];

    $cli_cedula = $referencia2->cedula;
    $cli_nombre = $referencia2->nombre;
    $cli_apelli = $referencia2->apellido;
    $cli_direc = $referencia2->direccion;
    $cli_tel = $referencia2->telefono;
    $cli_nombref1 = $referencia2->nombre_y_apellido1;
    $cli_telref1 = $referencia2->telefono1;
    $cli_nombref2 = $referencia2->nombre_y_apellido2;
    $cli_telref2 = $referencia2->telefono2;
    $cli_nombref3 = $referencia2->nombre_y_apellido3;
    $cli_telref3 = $referencia2->telefono3;
    $cli_nombref4 = $referencia2->nombre_y_apellido4;
    $cli_telref4 = $referencia2->telefono4;
    $coordenadas = $this->extractLatLong($referencia2->maps_link);
    $cli_ubicacion = $coordenadas['latitude'] . ", " . $coordenadas['longitude'];

    // si cliente existe en local, se actualiza, o sino, se inserta
    $connection = ConnectionManager::get('local');
    $sql00 = "select cli_cod from clientes where rtrim(cli_cedula)='$cli_cedula';";
    $statement00 = $connection->execute($sql00);
    $result = $statement00->fetch('assoc');
    //debug($result);
    //exit();

    if ($result) {
      $cli_cod = $result['cli_cod'];
    } else {
      $sql00 = "select max(cli_cod) as max_cli_cod from clientes";
      $statement00 = $connection->execute($sql00);
      $result = $statement00->fetch('assoc');
      $cli_cod = $result['max_cli_cod'] + 1;
    }

    if ($this->Referencia2->save($referencia2)) {

      $this->Flash->success("Estado Actualizado !");

      try {
        $clienteslocal = $this->Clienteslocal->get($cli_cod);
      } catch (RecordNotFoundException $e) {
        $clienteslocal = $this->Clienteslocal->newEntity();
        $clienteslocal->cli_cod = $cli_cod;
      }

      $clienteslocal->cli_cedula = $cli_cedula;
      $clienteslocal->cli_nombre = $cli_nombre;
      $clienteslocal->cli_apelli = $cli_apelli;
      $clienteslocal->cli_direc = $cli_direc;
      $clienteslocal->cli_tel = $cli_tel;
      $clienteslocal->cli_nombref1 = $cli_nombref1;
      $clienteslocal->cli_telref1 = $cli_telref1;
      $clienteslocal->cli_nombref2 = $cli_nombref2;
      $clienteslocal->cli_telref2 = $cli_telref2;
      $clienteslocal->cli_nombref3 = $cli_nombref3;
      $clienteslocal->cli_telref3 = $cli_telref3;
      $clienteslocal->cli_nombref4 = $cli_nombref4;
      $clienteslocal->cli_telref4 = $cli_telref4;
      $clienteslocal->cli_ubicacion = $cli_ubicacion;
      $clienteslocal->cli_vendedor = $empleado;

      if (!$this->Clienteslocal->save($clienteslocal)) {
        $this->Flash->error("Error al registrar cliente local..");
      }
    } else {
      $this->Flash->error("Error al actualizar estado de la referencia.");
    }
    return $this->redirect(['controller' => 'Referencia2', 'action' => 'view', $idreferencia]);
  }

  function extractLatLong($url)
  {
    preg_match('/@([-+]?[0-9]*\.?[0-9]+),([-+]?[0-9]*\.?[0-9]+)/', $url, $matches);
    if (count($matches) === 3) {
      return [
        'latitude' => $matches[1],
        'longitude' => $matches[2],
      ];
    }
    return null; // No se encontraron coordenadas
  }
}
