<?php
namespace App\Controller;

use App\Controller\AppController;

/**
 * Responsableorden Controller
 *
 * @property \App\Model\Table\ResponsableordenTable $Responsableorden
 *
 * @method \App\Model\Entity\Responsableorden[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class ResponsableordenController extends AppController
{

    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        $responsableorden = $this->paginate($this->Responsableorden);

        $this->set(compact('responsableorden'));
    }

    /**
     * View method
     *
     * @param string|null $id Responsableorden id.
     * @return \Cake\Http\Response|void
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $responsableorden = $this->Responsableorden->get($id, [
            'contain' => []
        ]);

        $this->set('responsableorden', $responsableorden);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $responsableorden = $this->Responsableorden->newEntity();
        if ($this->request->is('post')) {
            $responsableorden = $this->Responsableorden->patchEntity($responsableorden, $this->request->getData());
            if ($this->Responsableorden->save($responsableorden)) {
                $this->Flash->success(__('The responsableorden has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The responsableorden could not be saved. Please, try again.'));
        }
        $this->set(compact('responsableorden'));
    }

    /**
     * Edit method
     *
     * @param string|null $id Responsableorden id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $responsableorden = $this->Responsableorden->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $responsableorden = $this->Responsableorden->patchEntity($responsableorden, $this->request->getData());
            if ($this->Responsableorden->save($responsableorden)) {
                $this->Flash->success(__('The responsableorden has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The responsableorden could not be saved. Please, try again.'));
        }
        $this->set(compact('responsableorden'));
    }

    /**
     * Delete method
     *
     * @param string|null $id Responsableorden id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $responsableorden = $this->Responsableorden->get($id);
        if ($this->Responsableorden->delete($responsableorden)) {
            $this->Flash->success(__('The responsableorden has been deleted.'));
        } else {
            $this->Flash->error(__('The responsableorden could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
