<?php
namespace App\Controller;

use App\Controller\AppController;
use Cake\ORM\TableRegistry ; 
use Cake\Datasource\ConnectionManager;

/**
 * Ventapordias Controller
 *
 * @property \App\Model\Table\VentapordiasTable $Ventapordias
 *
 * @method \App\Model\Entity\Ventapordia[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class VentapordiasController extends AppController
{

    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        $ventapordias = $this->paginate($this->Ventapordias);

        $this->set(compact('ventapordias'));
    }

    public function dia($dia = null)
    {
        $diasmostrar = str_replace("-","/",$dia);
        $this->paginate = [
            'conditions' => ['fecha' => $diasmostrar],
            'order' => [
              'id' => 'asc' 
            ]
        ];
        $ventapordias = $this->paginate($this->Ventapordias);

        $this->set(compact('ventapordias'));
    }
    
    
     public function venta()
    {
       
       
         
        if(!empty($this->request->query['ano'])){
             $mesletra=array(1=>"ENERO","FEBRERO","MARZO","ABRIL","MAYO","JUNIO","JULIO","AGOSTO","SEPTIEMBRE","OCTUBRE","NOVIEMBRE","DICIEMBRE");
             
            $ano = $this->request->query['ano'];
            $mes = $this->request->query['mes'];
            
            
            $anos=array(1=>"2019","2020","2021","2022", "2023", "2024");
            
            $meses=array(1=>"01","02","03","04","05","06","07","08","09","10","11","12");
            $ultimodia=array(1=>"31","29","31","30","31","30","31","31","30","31","30","31");
            
            
            $desde = "01/".$meses[$mes]."/".$anos[$ano];
            $hasta = $ultimodia[$mes]."/".$meses[$mes]."/".$anos[$ano];
        
            $sqlwhere = "to_date(fecha,'dd/MM/yyyy')  between to_date('".$desde."','dd/mm/yyyy') and to_date('".$hasta."','dd/mm/yyyy') ";
       
            $this->paginate = [
                'conditions' => [$sqlwhere],
                'order' => [
                  'id' => 'asc' 
                ]
            ];
            $ventapordias = $this->paginate($this->Ventapordias);
    
            $this->set(compact('ventapordias'));
            $this->set('detalle', ' desde : ' . $desde . ' - hasta: ' . $hasta);
        }
    }
    

    /**
     * View method
     *
     * @param string|null $id Ventapordia id.
     * @return \Cake\Http\Response|void
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $ventapordia = $this->Ventapordias->get($id, [
            'contain' => []
        ]);

        $tocks  =  TableRegistry::get('cotizacions');
        $query = $tocks->find('all');
        $venta = 0;
        $compra = 0;
        foreach ($query as $coti):
          $venta = $coti->doven;
          $compra = $coti->docom;
        endforeach;
        $this->set('cotizacionventa',  $venta);
        
        $this->set('ventapordia', $ventapordia);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $ventapordia = $this->Ventapordias->newEntity();
        if ($this->request->is('post')) {
            $ventapordia = $this->Ventapordias->patchEntity($ventapordia, $this->request->getData());
            if ($this->Ventapordias->save($ventapordia)) {
                $this->Flash->success(__('The ventapordia has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The ventapordia could not be saved. Please, try again.'));
        }
        $this->set(compact('ventapordia'));
    }

    /**
     * Edit method
     *
     * @param string|null $id Ventapordia id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $ventapordia = $this->Ventapordias->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $ventapordia = $this->Ventapordias->patchEntity($ventapordia, $this->request->getData());
            if ($this->Ventapordias->save($ventapordia)) {
                $this->Flash->success(__('The ventapordia has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The ventapordia could not be saved. Please, try again.'));
        }
        $this->set(compact('ventapordia'));
    }

    /**
     * Delete method
     *
     * @param string|null $id Ventapordia id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $ventapordia = $this->Ventapordias->get($id);
        if ($this->Ventapordias->delete($ventapordia)) {
            $this->Flash->success(__('The ventapordia has been deleted.'));
        } else {
            $this->Flash->error(__('The ventapordia could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
