<?php

namespace App\Controller;

use App\Controller\AppController;
use Cake\Datasource\ConnectionManager;

class ViewventacabController extends AppController
{

    public function index()
    {

        if (!empty($this->request->query['search'])) {
            $search = $this->request->query['search'];
            $search = preg_replace('/[^a-zA-ZñÑáéíóúÁÉÍÓÚ0-9 ]/', '', $search);
            $terms = explode(' ', trim($search));
            $terms = array_diff($terms, array(''));

            foreach ($terms as $term) {
                $terms1[] = preg_replace('/[^a-zA-ZñÑáéíóúÁÉÍÓÚ0-9 ]/', '', $term);
                $conditions[] = array(
                    'OR' => array(
                        array('viewventacab.apellido LIKE' => '%' . strtoupper($term) . '%'),
                        array('viewventacab.nombre LIKE' => '%' . strtoupper($term) . '%'),
                    )
                );
            }

            $viewventacab = $this->Viewventacab->find('all', array('recursive' => -1, 'conditions' => $conditions, 'limit' => 200, 'order' => ['viewventacab.id' => 'desc']));
            $this->set('viewventacab', $this->paginate($viewventacab));
        } else {

            $viewventacab = $this->paginate($this->Viewventacab);

            $this->set(compact('viewventacab'));
        }
    }

    public function addseguro()
    {
        $this->render(false);
        if ($this->request->is('post')) {
            $itemId = $this->request->getData("id");
            $seguro = $this->request->getData("seguro");
            $sql = "UPDATE ventacab SET ven_seguro=" . $seguro . " WHERE ven_nro=" . $itemId;

            $connection = ConnectionManager::get('default');
            $connection_local = ConnectionManager::get('local');

            $connection->execute($sql);
            $connection->commit();
            $connection->disconnect();

            try {
                $connection_local->execute($sql);
                $connection_local->commit();
                $connection_local->disconnect();
            } catch (\Exception $e) {
                $this->Flash->error(__('Hubo un error al agregar el SEGURO: {0}', $e->getMessage()));
            }


            // Si la lógica de guardado fue exitosa
            $response = ['success' => true];
            echo json_encode($response);
        } else {
            // Si la solicitud no es una petición AJAX
            $response = ['success' => false];
            echo json_encode($response);
        }
    }

    public function addaprobmantenimiento()
    {
        $this->render(false);
        if ($this->request->is('post')) {
            $itemId = $this->request->getData("id");
            $mantenimiento = $this->request->getData("mantenimiento");
            $sql = "UPDATE ventacab SET ven_aprob_mantenimiento=" . $mantenimiento . " WHERE ven_nro=" . $itemId;

            $connection = ConnectionManager::get('default');
            $connection_local = ConnectionManager::get('local');

            $connection->execute($sql);
            $connection->commit();
            $connection->disconnect();

            try {
                $connection_local->execute($sql);
                $connection_local->commit();
                $connection_local->disconnect();
            } catch (\Exception $e) {
                $this->Flash->error(__('Hubo un error al agregar el MANTENIMIENTO: {0}', $e->getMessage()));
            }

            // Si la lógica de guardado fue exitosa
            $response = ['success' => true];
            echo json_encode($response);
        } else {
            // Si la solicitud no es una petición AJAX
            $response = ['success' => false];
            echo json_encode($response);
        }
    }
}
