<?php
namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Adelantos Model
 *
 * @method \App\Model\Entity\Adelanto get($primaryKey, $options = [])
 * @method \App\Model\Entity\Adelanto newEntity($data = null, array $options = [])
 * @method \App\Model\Entity\Adelanto[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\Adelanto|bool save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Adelanto patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\Adelanto[] patchEntities($entities, array $data, array $options = [])
 * @method \App\Model\Entity\Adelanto findOrCreate($search, callable $callback = null, $options = [])
 */
class AdelantosTable extends Table
{

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->table('adelantos');
        $this->displayField('id');
        $this->primaryKey('id');
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        $validator
            ->integer('id')
            ->allowEmpty('id', 'create');

        $validator
            ->integer('empleado')
            ->allowEmpty('empleado');

        $validator
            ->allowEmpty('fecha');

        $validator
            ->allowEmpty('detalle');

        $validator
            ->numeric('monto')
            ->allowEmpty('monto');

        $validator
            ->allowEmpty('moneda');

        return $validator;
    }
}
