<?php
namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Aprobarventas Model
 *
 * @method \App\Model\Entity\Aprobarventa get($primaryKey, $options = [])
 * @method \App\Model\Entity\Aprobarventa newEntity($data = null, array $options = [])
 * @method \App\Model\Entity\Aprobarventa[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\Aprobarventa|bool save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Aprobarventa|bool saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Aprobarventa patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\Aprobarventa[] patchEntities($entities, array $data, array $options = [])
 * @method \App\Model\Entity\Aprobarventa findOrCreate($search, callable $callback = null, $options = [])
 */
class AprobarventasTable extends Table
{

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->setTable('aprobarventas');
        $this->setDisplayField('id');
        $this->setPrimaryKey('id');
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        $validator
            ->integer('id')
            ->allowEmpty('id');

        $validator
            ->scalar('fecha')
            ->maxLength('fecha', 10)
            ->allowEmpty('fecha');

        $validator
            ->scalar('cedula')
            ->maxLength('cedula', 100)
            ->allowEmpty('cedula');

        $validator
            ->scalar('cliente')
            ->allowEmpty('cliente');

        $validator
            ->scalar('chasis')
            ->allowEmpty('chasis');

        $validator
            ->numeric('ventatotal')
            ->allowEmpty('ventatotal');

        $validator
            ->scalar('formadepago')
            ->allowEmpty('formadepago');

        $validator
            ->scalar('vendedor')
            ->allowEmpty('vendedor');

        $validator
            ->scalar('moneda')
            ->allowEmpty('moneda');

        $validator
            ->numeric('entregaminima')
            ->allowEmpty('entregaminima');

        $validator
            ->numeric('entregatotal')
            ->allowEmpty('entregatotal');

        $validator
            ->numeric('saldo')
            ->allowEmpty('saldo');

        $validator
            ->integer('cantidadcuota')
            ->allowEmpty('cantidadcuota');

        $validator
            ->scalar('us_login')
            ->maxLength('us_login', 50)
            ->allowEmpty('us_login');

        $validator
            ->scalar('aprobado')
            ->maxLength('aprobado', 250)
            ->allowEmpty('aprobado');

        $validator
            ->numeric('comision')
            ->allowEmpty('comision');

        $validator
            ->numeric('costo')
            ->allowEmpty('costo');

        return $validator;
    }
}
