<?php
namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * CambioVolantes Model
 *
 * @method \App\Model\Entity\CambioVolante get($primaryKey, $options = [])
 * @method \App\Model\Entity\CambioVolante newEntity($data = null, array $options = [])
 * @method \App\Model\Entity\CambioVolante[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\CambioVolante|bool save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\CambioVolante|bool saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\CambioVolante patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\CambioVolante[] patchEntities($entities, array $data, array $options = [])
 * @method \App\Model\Entity\CambioVolante findOrCreate($search, callable $callback = null, $options = [])
 */
class CambioVolantesTable extends Table
{

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->setTable('cambio_volantes');
        $this->setDisplayField('id');
        $this->setPrimaryKey('id');
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        $validator
            ->integer('id')
            ->allowEmpty('id', 'create');

        $validator
            ->scalar('nombre')
            ->maxLength('nombre', 250)
            ->allowEmpty('nombre');

        $validator
            ->numeric('pago')
            ->allowEmpty('pago');

        $validator
            ->scalar('fecha')
            ->maxLength('fecha', 150)
            ->allowEmpty('fecha');

        $validator
            ->scalar('chasis')
            ->maxLength('chasis', 250)
            ->allowEmpty('chasis');

        $validator
            ->scalar('modelo')
            ->maxLength('modelo', 250)
            ->allowEmpty('modelo');

        $validator
            ->scalar('color')
            ->maxLength('color', 150)
            ->allowEmpty('color');

        $validator
            ->integer('cancelado')
            ->allowEmpty('cancelado');

        $validator
            ->numeric('adelanto')
            ->allowEmpty('adelanto');

        $validator
            ->integer('borrado')
            ->allowEmpty('borrado');

        $validator
            ->scalar('fechacarga')
            ->maxLength('fechacarga', 150)
            ->allowEmpty('fechacarga');

        $validator
            ->integer('usuariocarga')
            ->allowEmpty('usuariocarga');

        $validator
            ->scalar('fechamodificado')
            ->maxLength('fechamodificado', 150)
            ->allowEmpty('fechamodificado');

        $validator
            ->integer('usuarioelimina')
            ->allowEmpty('usuarioelimina');

        return $validator;
    }
}
