<?php
namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Cotizacions Model
 *
 * @method \App\Model\Entity\Cotizacion get($primaryKey, $options = [])
 * @method \App\Model\Entity\Cotizacion newEntity($data = null, array $options = [])
 * @method \App\Model\Entity\Cotizacion[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\Cotizacion|bool save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Cotizacion patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\Cotizacion[] patchEntities($entities, array $data, array $options = [])
 * @method \App\Model\Entity\Cotizacion findOrCreate($search, callable $callback = null, $options = [])
 */
class CotizacionsTable extends Table
{

    
    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->table('cotizacions');
        $this->displayField('id');
        $this->primaryKey('id');
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        $validator
            ->integer('id')
            ->allowEmpty('id');

        $validator
            ->allowEmpty('fecha');

        $validator
            ->numeric('docom')
            ->allowEmpty('docom');

        $validator
            ->numeric('doven')
            ->allowEmpty('doven');

        $validator
            ->numeric('pecom')
            ->allowEmpty('pecom');

        $validator
            ->numeric('peven')
            ->allowEmpty('peven');

        $validator
            ->numeric('recom')
            ->allowEmpty('recom');

        $validator
            ->numeric('reven')
            ->allowEmpty('reven');

        $validator
            ->numeric('eucom')
            ->allowEmpty('eucom');

        $validator
            ->numeric('euven')
            ->allowEmpty('euven');

        $validator
            ->allowEmpty('maquinasct');

        return $validator;
    }
}
