<?php
namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Liquisalarios Model
 *
 * @method \App\Model\Entity\Liquisalario get($primaryKey, $options = [])
 * @method \App\Model\Entity\Liquisalario newEntity($data = null, array $options = [])
 * @method \App\Model\Entity\Liquisalario[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\Liquisalario|false save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Liquisalario saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Liquisalario patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\Liquisalario[] patchEntities($entities, array $data, array $options = [])
 * @method \App\Model\Entity\Liquisalario findOrCreate($search, callable $callback = null, $options = [])
 */
class LiquisalariosTable extends Table
{
    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);
        $this->setPrimaryKey('id');
        $this->setTable('liquisalarios');
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        $validator
            ->integer('id')
            ->allowEmptyString('id');

        $validator
            ->integer('empleadonro')
            ->allowEmptyString('empleadonro');

        $validator
            ->scalar('documento')
            ->allowEmptyString('documento');

        $validator
            ->scalar('empleado')
            ->allowEmptyString('empleado');

        $validator
            ->scalar('direccion')
            ->allowEmptyString('direccion');

        $validator
            ->scalar('inicio')
            ->maxLength('inicio', 10)
            ->allowEmptyString('inicio');

        $validator
            ->scalar('fin')
            ->maxLength('fin', 10)
            ->allowEmptyString('fin');

        $validator
            ->numeric('salario')
            ->allowEmptyString('salario');

        $validator
            ->numeric('total_comision')
            ->allowEmptyString('total_comision');

        $validator
            ->numeric('total_metas')
            ->allowEmptyString('total_metas');

        $validator
            ->numeric('otros_ingresos')
            ->allowEmptyString('otros_ingresos');

        $validator
            ->numeric('deuda_empresa')
            ->allowEmptyString('deuda_empresa');

        $validator
            ->numeric('adelanto')
            ->allowEmptyString('adelanto');

        $validator
            ->numeric('cobrar')
            ->allowEmptyString('cobrar');

        return $validator;
    }
}
