<?php
namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Listadodetalles Model
 *
 * @method \App\Model\Entity\Listadodetalle get($primaryKey, $options = [])
 * @method \App\Model\Entity\Listadodetalle newEntity($data = null, array $options = [])
 * @method \App\Model\Entity\Listadodetalle[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\Listadodetalle|false save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Listadodetalle saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Listadodetalle patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\Listadodetalle[] patchEntities($entities, array $data, array $options = [])
 * @method \App\Model\Entity\Listadodetalle findOrCreate($search, callable $callback = null, $options = [])
 */
class ListadodetallesTable extends Table
{
    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->setTable('listadodetalles');
        $this->setDisplayField('id');
        $this->setPrimaryKey('id');

        $this->belongsTo('Liquisalarios', [
            'foreignKey' => 'liquisalarioid',
            'joinType' => 'INNER',
        ]);
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        $validator
            ->integer('id')
            ->allowEmptyString('id');

        $validator
            ->integer('liquisalarioid')
            ->allowEmptyString('liquisalarioid');

        $validator
            ->scalar('detalle')
            ->allowEmptyString('detalle');

        $validator
            ->numeric('monto')
            ->allowEmptyString('monto');

        $validator
            ->scalar('moneda')
            ->allowEmptyString('moneda');

        return $validator;
    }
}
