<?php
namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * PropuestasFerias Model
 *
 * @method \App\Model\Entity\PropuestasFeria get($primaryKey, $options = [])
 * @method \App\Model\Entity\PropuestasFeria newEntity($data = null, array $options = [])
 * @method \App\Model\Entity\PropuestasFeria[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\PropuestasFeria|bool save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\PropuestasFeria|bool saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\PropuestasFeria patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\PropuestasFeria[] patchEntities($entities, array $data, array $options = [])
 * @method \App\Model\Entity\PropuestasFeria findOrCreate($search, callable $callback = null, $options = [])
 */
class PropuestasFeriasTable extends Table
{

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->setTable('propuestas_ferias');
        $this->setDisplayField('id');
        $this->setPrimaryKey('id');
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        $validator
            ->integer('id')
            ->allowEmpty('id', 'create');

        $validator
            ->scalar('nombre')
            ->maxLength('nombre', 255)
            ->requirePresence('nombre', 'create')
            ->notEmpty('nombre');

        $validator
            ->scalar('celular')
            ->maxLength('celular', 150)
            ->requirePresence('celular', 'create')
            ->notEmpty('celular');

        $validator
            ->scalar('propuesta')
            ->maxLength('propuesta', 255)
            ->requirePresence('propuesta', 'create')
            ->notEmpty('propuesta');

        $validator
            ->scalar('observacion')
            ->maxLength('observacion', 150)
            ->allowEmpty('observacion');

        $validator
            ->scalar('chasis')
            ->maxLength('chasis', 150)
            ->allowEmpty('chasis');

        $validator
            ->numeric('bono')
            ->allowEmpty('bono');

        $validator
            ->scalar('respuestagerente')
            ->maxLength('respuestagerente', 250)
            ->allowEmpty('respuestagerente');

        $validator
            ->integer('estado')
            ->allowEmpty('estado');

        $validator
            ->integer('usuario')
            ->allowEmpty('usuario');

        $validator
            ->scalar('photo')
            ->maxLength('photo', 255)
            ->allowEmpty('photo');

        $validator
            ->scalar('photo_dir')
            ->maxLength('photo_dir', 255)
            ->allowEmpty('photo_dir');

        $validator
            ->scalar('fecha')
            ->maxLength('fecha', 50)
            ->allowEmpty('fecha');

        $validator
            ->scalar('hora')
            ->maxLength('hora', 50)
            ->allowEmpty('hora');

        $validator
            ->scalar('vendedor')
            ->maxLength('vendedor', 200)
            ->allowEmpty('vendedor');

        return $validator;
    }
}
