<?php
namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Stocktodos Model
 *
 * @method \App\Model\Entity\Stocktodo get($primaryKey, $options = [])
 * @method \App\Model\Entity\Stocktodo newEntity($data = null, array $options = [])
 * @method \App\Model\Entity\Stocktodo[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\Stocktodo|bool save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Stocktodo|bool saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Stocktodo patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\Stocktodo[] patchEntities($entities, array $data, array $options = [])
 * @method \App\Model\Entity\Stocktodo findOrCreate($search, callable $callback = null, $options = [])
 */
class StocktodosTable extends Table
{

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->setTable('stocktodos');
        $this->setDisplayField('id');
        $this->setPrimaryKey('id');
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        $validator
            ->integer('id')
            ->allowEmpty('id');

        $validator
            ->scalar('tipo')
            ->allowEmpty('tipo');

        $validator
            ->scalar('marca')
            ->allowEmpty('marca');

        $validator
            ->scalar('modelo')
            ->allowEmpty('modelo');

        $validator
            ->scalar('ano')
            ->allowEmpty('ano');

        $validator
            ->scalar('color')
            ->allowEmpty('color');

        $validator
            ->scalar('chasis')
            ->allowEmpty('chasis');

        $validator
            ->scalar('observacion')
            ->allowEmpty('observacion');

        $validator
            ->numeric('entregaminima')
            ->allowEmpty('entregaminima');

        $validator
            ->numeric('contado3meses')
            ->allowEmpty('contado3meses');

        $validator
            ->numeric('meses12')
            ->allowEmpty('meses12');

        $validator
            ->numeric('meses18')
            ->allowEmpty('meses18');

        $validator
            ->numeric('contado')
            ->allowEmpty('contado');

        $validator
            ->numeric('costo')
            ->allowEmpty('costo');

        $validator
            ->scalar('estado')
            ->allowEmpty('estado');

        $validator
            ->scalar('sena')
            ->allowEmpty('sena');

        $validator
            ->scalar('sucursal')
            ->allowEmpty('sucursal');

        $validator
            ->scalar('ubicacion')
            ->allowEmpty('ubicacion');

        $validator
            ->numeric('contadogs')
            ->allowEmpty('contadogs');

        $validator
            ->scalar('deportivo')
            ->allowEmpty('deportivo');

        $validator
            ->scalar('fechaingreso')
            ->allowEmpty('fechaingreso');

        $validator
            ->numeric('stock')
            ->allowEmpty('stock');

        return $validator;
    }
}
