<?php
namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * TipoTrabajo Model
 *
 * @method \App\Model\Entity\TipoTrabajo get($primaryKey, $options = [])
 * @method \App\Model\Entity\TipoTrabajo newEntity($data = null, array $options = [])
 * @method \App\Model\Entity\TipoTrabajo[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\TipoTrabajo|bool save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\TipoTrabajo|bool saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\TipoTrabajo patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\TipoTrabajo[] patchEntities($entities, array $data, array $options = [])
 * @method \App\Model\Entity\TipoTrabajo findOrCreate($search, callable $callback = null, $options = [])
 */
class TipoTrabajoTable extends Table
{

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);

        $this->setTable('tipo_trabajo');
        $this->setDisplayField('tip_precio');
        $this->setPrimaryKey('tip_id');
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        $validator
            ->integer('tip_id')
            ->allowEmpty('tip_id', 'create');

        $validator
            ->scalar('tip_nombre')
            ->maxLength('tip_nombre', 250)
            ->allowEmpty('tip_nombre');

        $validator
            ->numeric('tip_precio')
            ->allowEmpty('tip_precio');

        $validator
            ->integer('tip_borrado')
            ->allowEmpty('tip_borrado');

        return $validator;
    }
}
