<?php
namespace App\Model\Table;

use Cake\ORM\Query;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Ventapordias Model
 *
 * @method \App\Model\Entity\Ventapordia get($primaryKey, $options = [])
 * @method \App\Model\Entity\Ventapordia newEntity($data = null, array $options = [])
 * @method \App\Model\Entity\Ventapordia[] newEntities(array $data, array $options = [])
 * @method \App\Model\Entity\Ventapordia|bool save(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Ventapordia|bool saveOrFail(\Cake\Datasource\EntityInterface $entity, $options = [])
 * @method \App\Model\Entity\Ventapordia patchEntity(\Cake\Datasource\EntityInterface $entity, array $data, array $options = [])
 * @method \App\Model\Entity\Ventapordia[] patchEntities($entities, array $data, array $options = [])
 * @method \App\Model\Entity\Ventapordia findOrCreate($search, callable $callback = null, $options = [])
 */
class VentapordiasTable extends Table
{

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config)
    {
        parent::initialize($config);
        $this->setTable('ventapordias');
        $this->setDisplayField('id');
        $this->setPrimaryKey('id');
    }

    /**
     * Default validation rules.
     *
     * @param \Cake\Validation\Validator $validator Validator instance.
     * @return \Cake\Validation\Validator
     */
    public function validationDefault(Validator $validator)
    {
        $validator
            ->integer('id')
            ->allowEmpty('id');

        $validator
            ->integer('credito')
            ->allowEmpty('credito');

        $validator
            ->scalar('empresa')
            ->allowEmpty('empresa');

        $validator
            ->scalar('ven_tipo')
            ->allowEmpty('ven_tipo');

        $validator
            ->scalar('cli_tel')
            ->maxLength('cli_tel', 50)
            ->allowEmpty('cli_tel');

        $validator
            ->scalar('detalle')
            ->allowEmpty('detalle');

        $validator
            ->integer('ven_nro')
            ->allowEmpty('ven_nro');

        $validator
            ->numeric('ven_moneda')
            ->allowEmpty('ven_moneda');

        $validator
            ->scalar('cliente')
            ->allowEmpty('cliente');

        $validator
            ->scalar('ci')
            ->maxLength('ci', 100)
            ->allowEmpty('ci');

        $validator
            ->scalar('factura')
            ->maxLength('factura', 50)
            ->allowEmpty('factura');

        $validator
            ->scalar('chasis')
            ->maxLength('chasis', 100)
            ->allowEmpty('chasis');

        $validator
            ->scalar('pro_detallelargo')
            ->maxLength('pro_detallelargo', 250)
            ->allowEmpty('pro_detallelargo');

        $validator
            ->integer('ve_moneda')
            ->allowEmpty('ve_moneda');

        $validator
            ->numeric('compra')
            ->allowEmpty('compra');

        $validator
            ->numeric('venta')
            ->allowEmpty('venta');

        $validator
            ->numeric('entrega')
            ->allowEmpty('entrega');

        $validator
            ->numeric('saldo')
            ->allowEmpty('saldo');

        $validator
            ->scalar('chasisvehiculo')
            ->maxLength('chasisvehiculo', 100)
            ->allowEmpty('chasisvehiculo');

        $validator
            ->scalar('fecha')
            ->allowEmpty('fecha');

        $validator
            ->scalar('vendedor')
            ->allowEmpty('vendedor');

        $validator
            ->scalar('imagen')
            ->allowEmpty('imagen');

        return $validator;
    }
}
