<?php
/**
  * @var \App\View\AppView $this
  */
?>
<nav class="large-3 medium-4 columns" id="actions-sidebar">
    <ul class="side-nav">
        <li class="heading"><?= __('Actiones') ?></li>
        <li><?= $this->Html->link(__('Nuevo Cotizacion'), ['action' => 'add']) ?></li>
    </ul>
</nav>
<div class="cotizacions index large-9 medium-8 columns content">
    <h3><?= __('Cotizacions') ?></h3>
    <table cellpadding="0" cellspacing="0">
        <thead>
            <tr>
                <th scope="col"><?= $this->Paginator->sort('id') ?></th>
                <th scope="col"><?= $this->Paginator->sort('fecha') ?></th>
                <th scope="col"><?= $this->Paginator->sort('docom') ?></th>
                <th scope="col"><?= $this->Paginator->sort('doven') ?></th>
                <th scope="col"><?= $this->Paginator->sort('pecom') ?></th>
                <th scope="col"><?= $this->Paginator->sort('peven') ?></th>
                <th scope="col"><?= $this->Paginator->sort('recom') ?></th>
                <th scope="col"><?= $this->Paginator->sort('reven') ?></th>
                <th scope="col"><?= $this->Paginator->sort('eucom') ?></th>
                <th scope="col"><?= $this->Paginator->sort('euven') ?></th>
                <th scope="col"><?= $this->Paginator->sort('maquinasct') ?></th>
                <th scope="col" class="actions"><?= __('Actiones') ?></th>
            </tr>
        </thead>
        <tbody>
            <?php foreach ($cotizacions as $cotizacion): ?>
            <tr>
                <td><?= $this->Number->format($cotizacion->id) ?></td>
                <td><?= h($cotizacion->fecha) ?></td>
                <td><?= $this->Number->format($cotizacion->docom) ?></td>
                <td><?= $this->Number->format($cotizacion->doven) ?></td>
                <td><?= $this->Number->format($cotizacion->pecom) ?></td>
                <td><?= $this->Number->format($cotizacion->peven) ?></td>
                <td><?= $this->Number->format($cotizacion->recom) ?></td>
                <td><?= $this->Number->format($cotizacion->reven) ?></td>
                <td><?= $this->Number->format($cotizacion->eucom) ?></td>
                <td><?= $this->Number->format($cotizacion->euven) ?></td>
                <td><?= h($cotizacion->maquinasct) ?></td>
                <td class="actions">
                    <?= $this->Html->link(__('Ver'), ['action' => 'view', $cotizacion->id]) ?>
                    <?= $this->Html->link(__('Editar'), ['action' => 'edit', $cotizacion->id]) ?>
                    <?= $this->Form->postLink(__('Borrar'), ['action' => 'delete', $cotizacion->id], ['confirm' => __('Desea eliminar registro # {0}?', $cotizacion->id)]) ?>
                </td>
            </tr>
            <?php endforeach; ?>
        </tbody>
    </table>
    <div class="paginator">
        <ul class="pagination">
            <?= $this->Paginator->first('<< ' . __('Primero')) ?>
            <?= $this->Paginator->prev('< ' . __('Anterior')) ?>
            <?= $this->Paginator->numbers() ?>
            <?= $this->Paginator->next(__('Siguiente') . ' >') ?>
            <?= $this->Paginator->last(__('Ultimo') . ' >>') ?>
        </ul>
        <p><?= $this->Paginator->counter(['format' => __('Pagina {{page}} de {{pages}}, mostrando {{current}} registro(s) de {{count}} total')]) ?></p>
    </div>
</div>
