<?php
/**
 * @var \App\View\AppView $this
 * @var \App\Model\Entity\InventarioUsado[]|\Cake\Collection\CollectionInterface $inventarioUsados
 */
?>
<nav class="large-3 medium-4 columns" id="actions-sidebar">
    <ul class="side-nav">
        <li class="heading"><?= __('Actions') ?></li>
        <li><?= $this->Html->link(__('New Inventario Usado'), ['action' => 'add']) ?></li>
    </ul>
</nav>
<div class="inventarioUsados index large-9 medium-8 columns content">
    <h3><?= __('Inventario Usados') ?></h3>
    <table cellpadding="0" cellspacing="0">
        <thead>
            <tr>
                <th scope="col"><?= $this->Paginator->sort('id') ?></th>
                <th scope="col"><?= $this->Paginator->sort('fecha') ?></th>
                <th scope="col"><?= $this->Paginator->sort('usuario') ?></th>
                <th scope="col"><?= $this->Paginator->sort('modelo') ?></th>
                <th scope="col"><?= $this->Paginator->sort('marca') ?></th>
                <th scope="col"><?= $this->Paginator->sort('color') ?></th>
                <th scope="col"><?= $this->Paginator->sort('chasis') ?></th>
                <th scope="col"><?= $this->Paginator->sort('cuentaaceite') ?></th>
                <th scope="col"><?= $this->Paginator->sort('motorfunciona') ?></th>
                <th scope="col"><?= $this->Paginator->sort('cajafunciona') ?></th>
                <th scope="col"><?= $this->Paginator->sort('chequin') ?></th>
                <th scope="col"><?= $this->Paginator->sort('radiotv') ?></th>
                <th scope="col"><?= $this->Paginator->sort('insigniatrasera') ?></th>
                <th scope="col"><?= $this->Paginator->sort('insigniadetalantera') ?></th>
                <th scope="col"><?= $this->Paginator->sort('cabeceras') ?></th>
                <th scope="col"><?= $this->Paginator->sort('bocina') ?></th>
                <th scope="col"><?= $this->Paginator->sort('aire') ?></th>
                <th scope="col"><?= $this->Paginator->sort('bloqueopuerta') ?></th>
                <th scope="col"><?= $this->Paginator->sort('tapizados') ?></th>
                <th scope="col"><?= $this->Paginator->sort('luces') ?></th>
                <th scope="col"><?= $this->Paginator->sort('espejos') ?></th>
                <th scope="col"><?= $this->Paginator->sort('herramientas') ?></th>
                <th scope="col"><?= $this->Paginator->sort('observacion') ?></th>
                <th scope="col" class="actions"><?= __('Actions') ?></th>
            </tr>
        </thead>
        <tbody>
            <?php foreach ($inventarioUsados as $inventarioUsado): ?>
            <tr>
                <td><?= $this->Number->format($inventarioUsado->id) ?></td>
                <td><?= h($inventarioUsado->fecha) ?></td>
                <td><?= $this->Number->format($inventarioUsado->usuario) ?></td>
                <td><?= h($inventarioUsado->modelo) ?></td>
                <td><?= h($inventarioUsado->marca) ?></td>
                <td><?= h($inventarioUsado->color) ?></td>
                <td><?= h($inventarioUsado->chasis) ?></td>
                <td><?= $this->Number->format($inventarioUsado->cuentaaceite) ?></td>
                <td><?= $this->Number->format($inventarioUsado->motorfunciona) ?></td>
                <td><?= $this->Number->format($inventarioUsado->cajafunciona) ?></td>
                <td><?= $this->Number->format($inventarioUsado->chequin) ?></td>
                <td><?= $this->Number->format($inventarioUsado->radiotv) ?></td>
                <td><?= $this->Number->format($inventarioUsado->insigniatrasera) ?></td>
                <td><?= $this->Number->format($inventarioUsado->insigniadetalantera) ?></td>
                <td><?= $this->Number->format($inventarioUsado->cabeceras) ?></td>
                <td><?= $this->Number->format($inventarioUsado->bocina) ?></td>
                <td><?= $this->Number->format($inventarioUsado->aire) ?></td>
                <td><?= $this->Number->format($inventarioUsado->bloqueopuerta) ?></td>
                <td><?= $this->Number->format($inventarioUsado->tapizados) ?></td>
                <td><?= $this->Number->format($inventarioUsado->luces) ?></td>
                <td><?= $this->Number->format($inventarioUsado->espejos) ?></td>
                <td><?= $this->Number->format($inventarioUsado->herramientas) ?></td>
                <td><?= h($inventarioUsado->observacion) ?></td>
                <td class="actions">
                    <?= $this->Html->link(__('View'), ['action' => 'view', $inventarioUsado->id]) ?>
                    <?= $this->Html->link(__('Edit'), ['action' => 'edit', $inventarioUsado->id]) ?>
                    <?= $this->Form->postLink(__('Delete'), ['action' => 'delete', $inventarioUsado->id], ['confirm' => __('Are you sure you want to delete # {0}?', $inventarioUsado->id)]) ?>
                </td>
            </tr>
            <?php endforeach; ?>
        </tbody>
    </table>
    <div class="paginator">
        <ul class="pagination">
            <?= $this->Paginator->first('<< ' . __('first')) ?>
            <?= $this->Paginator->prev('< ' . __('previous')) ?>
            <?= $this->Paginator->numbers() ?>
            <?= $this->Paginator->next(__('next') . ' >') ?>
            <?= $this->Paginator->last(__('last') . ' >>') ?>
        </ul>
        <p><?= $this->Paginator->counter(['format' => __('Page {{page}} of {{pages}}, showing {{current}} record(s) out of {{count}} total')]) ?></p>
    </div>
</div>
