<?php
$isMobile = $this->request->is('mobile');
$this->Html->scriptBlock('function isMobile() {return window.innerWidth <= 768;}', ['block' => true]);
?>
<?= $this->Html->css('bootstrap.min.css') ?>

<div class="row">
    <div class="col-md-12">
        <div class="page-header">
            <h4 align="center">LISTADO DE VEHICULOS - SEÑADOS EMPRESA</h4>
            <div class="container-fluid">
                <?php echo $this->Form->create('Stocks', array('type' => 'GET', 'url' => array('controller' => 'Stocks', 'action' => 'senadosempresa'))); ?>
                <div class="row">
                    <div class="col-md-9 col-xs-12">
                        <?php echo $this->Form->input('search', array('label' => false, 'div' => false, 'id' => 's', 'value' => $search, 'class' => 'form-control', 'autocomplete' => 'off', 'placeholder' => 'Chassis o modelo...')); ?>
                    </div>
                    <div class="col-md-3 col-xs-12">
                        <?php echo $this->Form->button('Buscar', array('div' => false, 'class' => 'btn btn-primary btn-block')); ?>
                    </div>
                </div>
                <?php echo $this->Form->end(); ?>
            </div>

        </div>

        <div class="table-responsive">
            <table class="table table-sm">
                <thead>
                    <tr>
                        <?php
                        if ($current_user['fotogrilla'] == 0) {
                        ?>
                            <th>&nbsp;</th>
                        <?php
                        }
                        ?>

                        <?php
                        if ($isMobile and $current_user['tipovista'] == 1) : ?>
                            <th>
                                <?= $this->Paginator->sort('modelo', ['Modelo']) ?><br>
                                <?= $this->Paginator->sort('ano', ['Año']) ?><br>
                                <?= $this->Paginator->sort('color', ['Color']) ?><br>
                                <?= $this->Paginator->sort('chasis', ['Chasis']) ?><br>
                                <?= $this->Paginator->sort('ubicacion', ['Ubicación']) ?>
                                <?= $this->Paginator->sort('estado', ['Estado']) ?>

                            </th>
                        <?php else : ?>
                            <th><?= $this->Paginator->sort('modelo', ['Modelo']) ?></th>
                            <th><?= $this->Paginator->sort('ano', ['Año']) ?></th>
                            <th><?= $this->Paginator->sort('color', ['Color']) ?></th>
                            <th><?= $this->Paginator->sort('chasis', ['Chasis']) ?></th>
                            <th><?= $this->Paginator->sort('ubicacion', ['Ubicación']) ?>
                            <th><?= $this->Paginator->sort('estado', ['Estado']) ?>

                            </th>
                        <?php endif; ?>

                        <?php $habilitados = array(1, 130, 364, 694);
                        // richard/martha/osmar/luism
                        ?>

                        <?php
                        if (in_array($current_user["id"], $habilitados)) :
                        ?>
                            <th>Accion</th>
                        <?php
                        endif;
                        ?>

                        <th>&nbsp;</th>
                    </tr>
                </thead>
                <tbody>
                    <?php foreach ($stocks as $stock) : ?>
                        <tr data-href='/stocks/view/<?= $stock->id ?>' <?php if ($stock->terminado == 1) { ?> style=" background-color: #E2FFE1" ; <?php } ?>>
                            <?php
                            if ($current_user['fotogrilla'] == 0) {
                            ?>
                                <td>
                                    <?php
                                    $imgfile = (WWW_ROOT . '/img/chasisthumbs/thumb_' . $stock->imagen);
                                    if (file_exists($imgfile)) :
                                        echo $this->Html->image('/img/chasisthumbs/thumb_' . $stock->imagen, array('width' => 80, 'height' => 60));
                                    else :
                                        echo $this->Html->image('/img/logohvn.png', array('width' => 80, 'height' => 60));
                                    endif;
                                    ?>

                                    <!-- <?php echo $this->Html->image('/img/chasisthumbs/thumb_' . $stock->imagen, array('width' => 80, 'height' => 60)); ?> -->
                                </td>
                            <?php
                            }
                            ?>

                            <?php
                            if ($isMobile and $current_user['tipovista'] == 1) : ?>
                                <td>
                                    <?= h($stock->modelo) ?><br>
                                    <?= h($stock->ano) ?><br>
                                    <?= h($stock->color) ?><br>
                                    <?= h($stock->chasis) ?><br>
                                    <?= array_slice(explode(' - ', $stock->ubicacion), 1)[0] ?>
                                    <?= h($stock->estado) ?><br>
                                </td>

                            <?php else : ?>
                                <td><?= h($stock->modelo) ?></td>
                                <td><?= h($stock->ano) ?></td>
                                <td><?= h($stock->color) ?></td>
                                <td><?= h($stock->chasis) ?></td>
                                <td><?= array_slice(explode(' - ', $stock->ubicacion), 1)[0] ?></td>
                                <td><?= h($stock->estado) ?></td>
                            <?php endif; ?>

                            <?php
                            // usuarios habilitados -- columnas ocultas
                            if (in_array($current_user["id"], $habilitados)) :
                            ?>
                            <?php
                            endif;
                            ?>

                            <td>
                                <?php echo $this->Html->link(
                                    'Eliminar Seña',
                                    [
                                        'controller' => 'Stocks', 'action' => 'aggremovesena', $stock->chasis,
                                    ],
                                    [
                                        'class' => 'btn btn-sm btn-info',
                                    ]
                                ); ?>
                            </td>
                            <td>
                                <?= $this->Html->link('VER', ['action' => 'view', $stock->id], ['class' => 'btn btn-sm btn-info']) ?>
                            </td>
                        </tr>
                    <?php endforeach; ?>
                </tbody>
            </table>
        </div>
        <div class="paginator">
            <ul class="pagination">
                <?= $this->Paginator->prev('< Anterior') ?>
                <?= $this->Paginator->numbers(['before' => '', 'after' => '']) ?>
                <?= $this->Paginator->next('Siguiente >') ?>
            </ul>
            <p><?= $this->Paginator->counter() ?></p>
        </div>
    </div>
</div>