<?php
/**
  * @var \App\View\AppView $this
  */
?>
<nav class="large-3 medium-4 columns" id="actions-sidebar">
    <ul class="side-nav">
        <li class="heading"><?= __('Actiones') ?></li>
        <li><?= $this->Html->link(__('Nuevo Users Empleado'), ['action' => 'add']) ?></li>
        <li><?= $this->Html->link(__('Listado Users'), ['controller' => 'Users', 'action' => 'index']) ?></li>
        <li><?= $this->Html->link(__('Nuevo User'), ['controller' => 'Users', 'action' => 'add']) ?></li>
        <li><?= $this->Html->link(__('Listado Empleados'), ['controller' => 'Empleados', 'action' => 'index']) ?></li>
        <li><?= $this->Html->link(__('Nuevo Empleado'), ['controller' => 'Empleados', 'action' => 'add']) ?></li>
    </ul>
</nav>
<div class="usersEmpleados index large-9 medium-8 columns content">
    <h3><?= __('Users Empleados') ?></h3>
    <table cellpadding="0" cellspacing="0">
        <thead>
            <tr>
                <th scope="col"><?= $this->Paginator->sort('id') ?></th>
                <th scope="col"><?= $this->Paginator->sort('user_id') ?></th>
                <th scope="col"><?= $this->Paginator->sort('empleado_id') ?></th>
                <th scope="col" class="actions"><?= __('Actiones') ?></th>
            </tr>
        </thead>
        <tbody>
            <?php foreach ($usersEmpleados as $usersEmpleado): ?>
            <tr>
                <td><?= $this->Number->format($usersEmpleado->id) ?></td>
                <td><?= $usersEmpleado->has('user') ? $this->Html->link($usersEmpleado->user->id, ['controller' => 'Users', 'action' => 'view', $usersEmpleado->user->id]) : '' ?></td>
                <td><?= $usersEmpleado->has('empleado') ? $this->Html->link($usersEmpleado->empleado->cedula, ['controller' => 'Empleados', 'action' => 'view', $usersEmpleado->empleado->id]) : '' ?></td>
                <td class="actions">
                    <?= $this->Html->link(__('Ver'), ['action' => 'view', $usersEmpleado->id]) ?>
                    <?= $this->Html->link(__('Editar'), ['action' => 'edit', $usersEmpleado->id]) ?>
                    <?= $this->Form->postLink(__('Borrar'), ['action' => 'delete', $usersEmpleado->id], ['confirm' => __('Desea eliminar registro # {0}?', $usersEmpleado->id)]) ?>
                </td>
            </tr>
            <?php endforeach; ?>
        </tbody>
    </table>
    <div class="paginator">
        <ul class="pagination">
            <?= $this->Paginator->first('<< ' . __('Primero')) ?>
            <?= $this->Paginator->prev('< ' . __('Anterior')) ?>
            <?= $this->Paginator->numbers() ?>
            <?= $this->Paginator->next(__('Siguiente') . ' >') ?>
            <?= $this->Paginator->last(__('Ultimo') . ' >>') ?>
        </ul>
        <p><?= $this->Paginator->counter(['format' => __('Pagina {{page}} de {{pages}}, mostrando {{current}} registro(s) de {{count}} total')]) ?></p>
    </div>
</div>
